#include "stdafx.h"
#include <String.h>
#include <Stdlib.h>

#define DEBUG 0

int BoardSize, BlockSize, BlockNumber=0, BlockPTR = 0;
char x_siluet[100], y_siluet[100], h[100], xmin[100], xmax[100], ymin[100], ymax[100], s[100];
char x_res[100], y_res[100];

int check() {
	int i, s, x, y;
	s = BlockSize - 1;
	x = x_res[BlockPTR];
	y = y_res[BlockPTR];

	for( i=0; i < BlockPTR; ++i) {
		if(x_res[i]<=(x)   && (x)  <=(x_res[i]+s) && y_res[i]<=(y)   && (y)  <=(y_res[i]+s)) return 0;
		if(x_res[i]<=(x)   && (x)  <=(x_res[i]+s) && y_res[i]<=(y+s) && (y+s)<=(y_res[i]+s)) return 0;
		if(x_res[i]<=(x+s) && (x+s)<=(x_res[i]+s) && y_res[i]<=(y)   && (y)  <=(y_res[i]+s)) return 0;
		if(x_res[i]<=(x+s) && (x+s)<=(x_res[i]+s) && y_res[i]<=(y+s) && (y+s)<=(y_res[i]+s)) return 0;
	}


	for( i=0; i < BlockSize; ++i) {
		if(x_siluet[x+i] < h[BlockPTR] || y_siluet[y+i] < h[BlockPTR]) return 0;
	}

	return 1;
}

int next()
{
	++x_res[BlockPTR];
	if( x_res[BlockPTR] > xmax[BlockPTR]) {
		if( y_res[BlockPTR] >= ymax[BlockPTR]) {	// Can't find
			x_res[BlockPTR] = y_res[BlockPTR] = -1;
			--BlockPTR;
			return 0;
		}
		x_res[BlockPTR] = xmin[BlockPTR];  ++y_res[BlockPTR];
	}
	return 1;
}

int find()
{
	if (x_res[BlockPTR] < 0)	{	// New Block
		x_res[BlockPTR] = xmin[BlockPTR];
		y_res[BlockPTR] = ymin[BlockPTR];
	} else {						// Existing Block
		if (next()==0) return 0;
	}

	while(1) {
		if (check()) {
			++BlockPTR; 
			x_res[BlockPTR] = y_res[BlockPTR] = -1;
			return 1;
		}
		if (next()==0) return 0;
	}

	return 0;
}


int compare( const void *arg1, const void *arg2 )
{
   int i;
   i = *(( char* ) arg2) - *(( char* ) arg1);
   return i;
}

void print_blocks(FILE *fo)
{
	int i;
	if(DEBUG) printf("\n\nprint_blocks BlockPTR=%d", BlockPTR);
	for( i= 0; i < BlockPTR; ++i) {
		if(DEBUG) printf("\nX=%d, Y=%d, H=%d", x_res[i], y_res[i], h[i]);
	
	}

	if(fo == NULL) return;

	if(BlockPTR==0) {
		fprintf(fo, "NO");
	} else {
		fprintf(fo, "%d", BlockPTR);
		for( i=BlockPTR-1; i >= 0 ; --i) {
			fprintf(fo,"\n%d %d %d", x_res[i], y_res[i], h[i]);
		}
	}
}

int main(int argc, char* argv[])
{
	char height, i, j, def;

	FILE *fi, *fo;
	height = 0;

	//fi = stdin;
	//fi = fopen("CON", "r");  
	//fo = fopen("CON", "w");
	fi = fopen("BLOCK.IN", "r");  
	fo = fopen("BLOCK.OUT", "w");

	fscanf(fi, "%d %d", &BoardSize, &BlockSize);
	for(i=0; i < BoardSize; ++i) {
		fscanf(fi, "%d", &height);	x_siluet[i] = height;
	}
	for(i=0; i < BoardSize; ++i) {
		fscanf(fi, "%d", &height);	y_siluet[i] = height;
	}

	if(DEBUG) printf("BoardSize=%d, BlockSize=%d", BoardSize, BlockSize);
	if(DEBUG) printf("\nX:"); for(i=0; i < BoardSize; ++i) if(DEBUG) printf("%d", x_siluet[i]);
	if(DEBUG) printf("  Y:"); for(i=0; i < BoardSize; ++i) if(DEBUG) printf("%d", y_siluet[i]);

	for(i=BlockNumber=0; i < BoardSize; ++i) {
		height = x_siluet[i];
		if (height) {
			for(j=0; j < BlockNumber && h[j] != height; ++j);
			if (j >= BlockNumber) h[BlockNumber++] = height;
		}
		height = y_siluet[i];
		if (height) {
			for(j=0; j < BlockNumber && h[j] != height; ++j);
			if (j >= BlockNumber) h[BlockNumber++] = height;
		}
	}

	//if(DEBUG) printf("\nH:"); for(i=0; h[i]; ++i) if(DEBUG) printf("%d",h[i]);

	qsort( (void *)h, BlockNumber, sizeof(char), compare );

	if(DEBUG) printf("\nH:"); for(i=0; h[i]; ++i) if(DEBUG) printf("%d",h[i]);

	for(i=0; i < BlockNumber; ++ i) {
		xmin[i]=xmax[i]=ymin[i]=ymax[i]=-1;
		for( j=0; j < BoardSize; ++j) {
			if(h[i] == x_siluet[j]) {
				if (xmin[i]<0 || xmin[i] > j) xmin[i]=j;
				if (xmax[i]<0 || xmax[i] < j) xmax[i]=j;
			}
		}

		for( j=0; j < BoardSize; ++j) {
			if(h[i] == y_siluet[j]) {
				if (ymin[i]<0 || ymin[i] > j) ymin[i]=j;
				if (ymax[i]<0 || ymax[i] < j) ymax[i]=j;
			}
		}

		for( j=ymin[i]+1; j <= ymax[i] && ymax[i] >= 0; ++j) {
			if (h[i] != y_siluet[j]) {
				if(DEBUG) printf("\nH[%d]=%d Wrong SILUET #1!",i, h[i]);
				fprintf(fo, "NO");  goto ex;;
			}
		}

		for( j=xmin[i]+1; j <= xmax[i] && xmax[i] >= 0; ++j) {
			if (h[i] != x_siluet[j]) {
				if(DEBUG) printf("\nH[%d]=%d Wrong SILUET #2!",i, h[i]);
				fprintf(fo, "NO");  goto ex;;
			}
		}

		
		if(DEBUG) printf("\nH[%d]=%d XMin=%d XMax=%d YMin=%d YMax=%d",i,h[i],xmin[i],xmax[i],ymin[i],ymax[i]);
		if((xmax[i] - xmin[i]) >= BlockSize || (ymax[i] - ymin[i]) >= BlockSize) {
			if(DEBUG) printf("\nH[%d]=%d Wrong SILUET! #3",i, h[i]);
			fprintf(fo, "NO");  goto ex;;
		}

		if(i==0 && ( (xmax[i] - xmin[i]+1) != BlockSize || (ymax[i] - ymin[i]+1) != BlockSize) ) {
			if(DEBUG) printf("\nH[%d]=%d Wrong SILUET! #4",i, h[i]);
			fprintf(fo, "NO");  goto ex;;
		}


		if (xmax[i] >= 0) {
			j = BlockSize - (xmax[i] - xmin[i] + 1);
			def=0;
			if (xmin[i]==0)								{ def=1; xmax[i] = xmin[i]+BlockSize-1; }
			else if (x_siluet[xmin[i]-1] < h[i])		{ def=1; xmax[i] = xmin[i]+BlockSize-1; }
			
			if (def==0 && xmax[i] == (BoardSize-1))		{ def=1; xmin[i] = xmax[i]-(BlockSize-1); }
			else if (x_siluet[xmax[i]+1] < h[i])		{ def=1; xmin[i] = xmax[i]-(BlockSize-1); }
			
			if (def==0) {
				xmin[i] = (xmin[i] < j) ? 0 : xmin[i] - j;
				xmax[i] = ((xmax[i] + j) >= BoardSize) ? BoardSize-1 : xmax[i] + j;
			}
		} else {
			xmin[i] = xmax[i] = -1;
			for( j=0; j < BoardSize; ++j) {
				if (h[i] < x_siluet[j] && xmin[i] < 0) xmin[i] = j;
				if (h[i] < x_siluet[BoardSize-j-1] && xmax[i] < 0)  xmax[i] = BoardSize-j-1;
			}
		}

		if (ymax[i] >= 0) {
			j = BlockSize - (ymax[i] - ymin[i] + 1);
			def=0;
			if (ymin[i]==1)								{ def=1; ymax[i] = ymin[i]+BlockSize-1; }
			else if (y_siluet[ymin[i]-1] < h[i])		{ def=1; ymax[i] = ymin[i]+BlockSize-1; }

			if (def==0 && ymax[i] == (BoardSize-1))		{ def=1; ymin[i] = ymax[i]-(BlockSize-1); }
			else if (y_siluet[ymax[i]+1] < h[i])		{ def=1; ymin[i] = ymax[i]-(BlockSize-1); }

			if (def==0) {
				ymin[i] = (ymin[i] < j) ? 0 : ymin[i] - j;
				ymax[i] = ((ymax[i] + j) >= BoardSize) ? BoardSize-1 : ymax[i] + j;
			}
		} else {
			ymin[i] = ymax[i] = -1;
			for( j=0; j < BoardSize; ++j) {
				if (h[i] < y_siluet[j] && ymin[i] < 0)  ymin[i] = j;
				if (h[i] < y_siluet[BoardSize-j-1] && ymax[i] < 0)  ymax[i] = BoardSize-j-1;
			}
		}

		xmax[i] -= BlockSize - 1;	ymax[i] -= BlockSize - 1;

		if(DEBUG) printf("\n\tH[%d]=%d XMin=%d XMax=%d YMin=%d YMax=%d",i,h[i],xmin[i],xmax[i],ymin[i],ymax[i]);
	}

	if(DEBUG) printf("\nH:"); for(i=0; h[i]; ++i) if(DEBUG) printf("%d",h[i]);

	BlockPTR=1;  x_res[0]=xmin[0];  y_res[0]=ymin[0];

	print_blocks(NULL);

	while(BlockPTR > 0 && BlockPTR < BlockNumber) {
		find();
	}

	print_blocks(fo);

ex:
	fclose(fi);  fclose(fo);

	return 0;
}