#include <stdio.h>
#include <stdlib.h>

inline int min (int x, int y)
{
	return (x < y) ? x : y;
}
inline int max (int x, int y)
{
	return (x > y) ? x : y;
}
inline int cmp (const void* aa, const void* bb)
{
	int* a = (int*) aa;
	int* b = (int*) bb;
	if (*a == *b) return 0;
	if (*a < *b) return 1;
	return -1;
}
int Solve (int, int);

FILE* fin = fopen ("block.in", "rt");
FILE* fout = fopen ("block.out", "wt");

struct
{
	struct
	{
		char x, y;
	} data[2000];
	int count, pos;
} Rec[101];

struct
{
	char avail_e, avail_s;
	char start_e, count_e;
	char start_s, count_s;
} Blocks[101];

int City[101][101];
int South [102], East[102];
int MinSouth [101], MinEast [101];
int Heights [101];
int he_count, he;

int main (void)
{
	int n, m;
	int i, j, max_e, max_s;
	int value, vis;
	int left, right, top, bottom;

	South[0] = East[0] = 200;
	fscanf (fin, "%d%d", &n, &m);			// vhod i populvane na nalichnite visochini
	for (i = 1; i <= n; i++)
	{
		fscanf (fin, "%d", &vis);
		South[i] = vis;
		if (vis == 0) continue;
		if (Blocks[vis].avail_s == 0)
		{
			Blocks[vis].avail_s = 1;
			Blocks[vis].start_s = i;
			Blocks[vis].count_s = 1;
		}
		else
		{
			if (South[i-1] != South[i]) goto NO;
			Blocks[vis].count_s++;
		}
	}
	for (i = 1; i <= n; i++)
	{
		fscanf (fin, "%d", &vis);
		East[i] = vis;
		if (vis == 0) continue;
		if (Blocks[vis].avail_e == 0)
		{
			Blocks[vis].avail_e = 1;
			Blocks[vis].start_e = i;
			Blocks[vis].count_e = 1;
		}
		else
		{
			if (East[i-1] != East[i]) goto NO;
			Blocks[vis].count_e++;
		}
	}

	he_count = 0;								// sortirane na visochinite
	for (vis = 1; vis <= 100; vis++)
		if (Blocks[vis].avail_e != 0 || Blocks[vis].avail_s != 0)
			Heights[he_count++] = vis;
	Heights[he_count] = 0;
	qsort (Heights, he_count, sizeof (int), cmp);

	for (i = 1; i <= n-m+1; i++)			// namirane na MAX dopustima visochina za vsjaka kletka
	{
		max_e = max_s = 200;
		for (j = 0; j < m; j++)
		{
			max_e = min (max_e, East[i+j]);
			max_s = min (max_s, South[i+j]);
		}
		MinEast[i] = max_e;
		MinSouth[i] = max_s;
	}
	for (i = 1; i <= n-m+1; i++)
		for (j = 1; j <= n-m+1; j++)
			City[i][j] = min (MinEast[i], MinSouth[j]);

	for (he = 0; he < he_count; he++)				// 'snijavane'
	{
		left = -1; right = 200;					// po South
		if (Blocks[Heights[he]].avail_s != 0)
		{
			right = Blocks[Heights[he]].start_s;
			left = max (1, Blocks[Heights[he]].start_s + Blocks[Heights[he]].count_s - m);
		}
		if (left > right) goto NO;

		for (j = 1; j < left; j++)
			for (i = 1; i <= n; i++)
				if (City[i][j] == Heights[he])
					City[i][j] = Heights[he+1];
		for (j = right+1; j <= n; j++)
			for (i = 1; i <= n; i++)
				if (City[i][j] == Heights[he])
					City[i][j] = Heights[he+1];

		if (left == -1)
		{
			left = 1;
			right = n;
		}

		bottom = -1; top = 200;						// po East
		if (Blocks[Heights[he]].avail_e != 0)
		{
			top = Blocks[Heights[he]].start_e;
			bottom = max (1, Blocks[Heights[he]].start_e + Blocks[Heights[he]].count_e - m);
		}

		if (bottom > top) goto NO;

		for (i = 1; i < bottom; i++)
			for (j = left; j <= right; j++)
				if (City[i][j] == Heights[he])
					City[i][j] = Heights[he+1];
		for (i = top+1; i <= n; i++)
			for (j = left; j <= right; j++)
				if (City[i][j] == Heights[he])
					City[i][j] = Heights[he+1];
	}

	for (i = 0; i < 101; i++)				// Filing the array for the recursion
		Rec[i].count = 0;
	for (i = 1; i <= n; i++)
		for (j = 1; j <= n; j++)
			if (City[i][j] != 0)
			{
				vis = City[i][j];
				Rec[vis].data[Rec[vis].count].x = i;
				Rec[vis].data[Rec[vis].count].y = j;
				Rec[vis].count++;
				City[i][j] = 0;
			}

	value = Solve (0, m);

	if (value == 0) goto NO;
	else
	{
		fprintf (fout, "%d\n", he_count);
		for (he = he_count-1; he >= 0; he--)
		{
			i = Rec[Heights[he]].data[Rec[Heights[he]].pos].x;
			j = Rec[Heights[he]].data[Rec[Heights[he]].pos].y;
			fprintf (fout, "%d %d %d\n", j-1, i-1, Heights[he]);
		}
		goto END;
	}
NO:
	fprintf (fout, "NO\n");
END:
	fclose (fin);
	fclose (fout);
	return 0;
}

int Solve (int height_index, int m)
{
	int i, j, x, y;
	int i_start, j_start, result;
	
	if (height_index == he_count) return 1;
	for (Rec[Heights[height_index]].pos = 0; Rec[Heights[height_index]].pos < Rec[Heights[height_index]].count; Rec[Heights[height_index]].pos++)
	{
		x = Rec[Heights[height_index]].data[Rec[Heights[height_index]].pos].x;
		y = Rec[Heights[height_index]].data[Rec[Heights[height_index]].pos].y;
		i_start = max(x-m+1, 1);
		j_start = max(y-m+1, 1);
		if (City[x][y] == 0)							// ako mojem da postavim tekushtija blok
		{
			for (i = i_start; i <= x+m-1; i++)			// postavjame go
				for (j = j_start; j <= y+m-1; j++)
					if (City[i][j] == 0)
						City[i][j] = Heights[height_index];

			result = Solve (height_index+1, m);			// postavjame po-niskite blokove
			if (result == 1) return 1;

			for (i = i_start; i <= x+m-1; i++)			// mahame bloka
				for (j = j_start; j <= y+m-1; j++)
					if (City[i][j] == Heights[height_index])
						City[i][j] = 0;
		}
	}
	return 0;
}