// Block.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <memory.h>
#include <stdlib.h>

class _Kvartal
{
public:
	_Kvartal(int n,int m,int ss[],int se[]);//CONSTRUCTOR
	int FindSolution();//Main function that solves the problem
	void SortEm(void);//Sorts the output if any
	int GetBlY(int i){return Blx[i];}//Some get functions
	int GetBlX(int i){return Bly[i];}//that offer an interface
	int GetBlH(int i){return Blh[i];}//to the class' private data
private:
	bool Try(int x,int y);//Checks's place for suitability
	void SetHard(void);//Resets the hard matrix
	void SetUsed(int x,int y);//Engages the square (x,y)-(x+M-1)(y+M-1)
	void ResetUsed(int x,int y);//Resets the place as free
	int Recurs(void);//Main recursive function to find the places

private:
	bool hard[100][100],vf[100];
	bool used[100][100],vu[100];
	int Square[100][100];
	int N,M;
	int SiluetS[100],SiluetE[100];
	int Blx[10],Bly[10],Blh[10],BN;
};
_Kvartal::_Kvartal(int n,int m,int ss[],int se[])
{
	N = n;
	M = m;
	BN = 0;
	memset(&vf,0,sizeof(vf));
	memset(&vu,0,sizeof(vu));
	memset(&Square,0,sizeof(Square));
	memset(&hard,0,sizeof(hard));
	memset(&used,0,sizeof(used));
	for(int i = 0;i < N;i++){
		SiluetS[i] = ss[i];
		SiluetE[i] = se[i];
		vf[ss[i]] = vf[se[i]] = true;
	}
}
void _Kvartal::SetHard(void)
{
	int i,j;
	for(i = 0;i < N;i++)
		for(j = 0;j < N;j++){
			if(SiluetS[i] && (SiluetS[i] == SiluetE[j]) && (!used[i][j]))hard[i][j] = true;
		}
}
bool _Kvartal::Try(int x,int y)
{
	int i,j;
	for(i = x;i < x + M;i++)
		for(j = y;j < y + M;j++){
			if(used[i][j])return false;
			if(Square[i][j] < Square[x][y])return false;
			else hard[i][j] = false;
		}
	for(i = 0;i < N;i++)
		for(j = 0;j < N;j++)
			if((Square[i][j] == Square[x][y]) && hard[i][j])return false;
	//SetHard();
	return true;
}
void _Kvartal::SetUsed(int x,int y)
{
	int i,j;
	for(i = x;i < x + M;i++)
		for(j = y;j < y + M;j++){
			used[i][j] = true;
			//hard[i][j] = false;
		}
}
void _Kvartal::ResetUsed(int x,int y)
{
	int i,j;
	for(i = x;i < x + M;i++)
		for(j = y;j < y + M;j++){
			used[i][j] = false;
			if(SiluetS[i] && (SiluetS[i] == SiluetE[j]))hard[i][j] = true;
		}
}
int _Kvartal::Recurs(void)
{
	int set = 0,i,j;
	for(i = 1;i < 100;i++)if(vf[i])set = 1;
	if(!set)return 1;
	for(j = 0;j < N-M;j++)
		for(i = 0;i < N-M;i++){
			if(Square[i][j] && (!used[i][j]) && (!vu[Square[i][j]]) && Try(i,j)){
				SetUsed(i,j);
				vu[Square[i][j]] = true;
				vf[Square[i][j]] = false;
				Blx[BN] = i;Bly[BN] = j;Blh[BN++] = Square[i][j];
				if(Recurs())return 1;
				vu[Square[i][j]] = false;
				vf[Square[i][j]] = true;
				BN--;
				ResetUsed(i,j);
			}	
		}
	return 0;
}
int _Kvartal::FindSolution()
{
	int i,j;
	for(i = 0;i < N;i++)
		for(j = 0;j < N;j++){
			if(SiluetS[i] && (SiluetS[i] == SiluetE[j]))hard[i][j] = true;
			if((SiluetS[i] != 0) && (SiluetE[j] != 0))
				Square[i][j] = __min(SiluetS[i],SiluetE[j]);
		}

	if(!Recurs())BN = 0;
	else for(i = 0;i < N;i++)for(j = 0;j < N;j++)if(hard[i][j])return 0;
	return BN;
}
void _Kvartal::SortEm()
{
	int t,i,j;
	for(i = 0;i < BN-1;i++)
		for(j = i;j < BN;j++)
			if(Blh[i] > Blh[j]){
				t = Blx[i];Blx[i] = Blx[j];Blx[j] = t;
				t = Bly[i];Bly[i] = Bly[j];Bly[j] = t;
				t = Blh[i];Blh[i] = Blh[j];Blh[j] = t;
			}
}

void FindSolution(void)
{
	FILE *f;
	int n,m,ss[100],se[100];
	f = fopen("BLOCK.IN","rt");
	fscanf(f,"%d %d",&n,&m);
	for(int i = 0;i < n;i++)fscanf(f,"%d",&ss[i]);
	for(i = 0;i < n;i++)fscanf(f,"%d",&se[i]);
	fclose(f);
	_Kvartal Kv(n,m,ss,se);
	m = Kv.FindSolution();
	f = fopen("BLOCK.OUT","wt");
	if(!m)fprintf(f,"NO");
	else{
		Kv.SortEm();
		fprintf(f,"%d\n",m);
		for(i = 0;i < m;i++)fprintf(f,"%d %d %d\n",Kv.GetBlX(i),Kv.GetBlY(i),Kv.GetBlH(i));
	}
	fclose(f);
}
int main(int argc, char* argv[])
{
	FindSolution();
	return 0;
}
