#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>
//=======================================================================
//=======================================================================
class cpretend
{
public:
	short index;
	short id;
	char bl;
	cpretend(){bl=0;id=index=0;}
};
//=======================================================================
//=======================================================================
struct sblock
{
	char beg;
	char end;
	char len;
	char edge1;
	char edge2;
};
//=======================================================================
//=======================================================================
class cconflict
{
public:
	char bl;
	short id;
	short index;
	short next;
	short back;
	cconflict(){bl=0;}
};
//=======================================================================
//=======================================================================
class svar
{
public:
	short back;
	short next;
	char x;
	char y;
	short count;
	short id;
	cconflict *prech;
	void remove(int index)
	{
		count--;
		if (index !=count)
			memmove(&prech[index], &prech[index+1], sizeof(cconflict)*(count-index));
	}
	svar(){count=0;next=back=0;}
};
//=======================================================================
//=======================================================================
class cblock
{
public:
	sblock view[2];
	char poseten;
	int exist;
	int found;
	char mark;
	int var_c;
	int a_var;
	int f_var;
	int first;
	svar *var;
	cblock();
	void hide(int index);
	void show(int index);
	void create(int c);
	void remove(int index);
//	~cblock();
};
//=======================================================================
void cblock::hide(int index)
{
	var_c--;
	if (index==first) first=var[index].next;
	var[var[index].back].next = var[index].next;
	var[var[index].next].back = var[index].back;
}
void cblock::show(int index)
{
	if (index<first) first=index;
	var_c++;
	var[var[index].next].back=var[var[index].back].next=index;
}
//=======================================================================
cblock::cblock()
{
	poseten=mark=var_c=exist=found=view[1].beg=view[1].edge1=view[1].edge2=view[1].end=view[1].len=view[0].beg=view[0].edge1=view[0].edge2=view[0].end=view[0].len=0;
	var = NULL;
	var_c=0;
	f_var=0;a_var=0;
	first=0;
}
//=======================================================================
void cblock::create(int c)
{
	var = new svar [(var_c = c) + 1];
}
//=======================================================================
//=======================================================================
void cblock::remove(int index)
{
	var_c--;
	if (index!=var_c)
		memmove(&var[index],&var[index+1],(sizeof(svar))*(var_c-index));
}
//=======================================================================
//=======================================================================
class cvar_id
{
public:
	char bl;
	short index;
	char rem;
	cvar_id(){bl=0;index=0;rem=0;}
};
class cgroup
{
public:
	int count;
	struct
	{
		char vis;
	}bl[101];
	cgroup()
	{
		count=0;
	}
//	~cgroup(){}
};
//=======================================================================
class cinput
{
public:
	int n;
	int m;
	cvar_id var_id[10001];
	char input[2][100];
	char output[100][100];
	cgroup groups[101];
	int group_c;
	int cur_group;
	cblock blocks[101];
	cinput(char * fname);
	void mark_good();
	void mark(char x, char y, char bl);
	void mark2(char x, char y, char bl);
	void unmark(char x, char y);
	int test(char x,char y);
	int solved;
	void var_all();
	void rem_fix();
	void rem_free();
	void set_conflicts();
	void make_goups();
	void group_rec();
	void add_group(int ind);
	void solve(int bind);
	void yes();
	void no();
	void next_back();
//	~cinput();
};
void cinput::next_back()
{
	int i,j;
	for (i=100;i>0;i--)
		if (blocks[i].exist && !blocks[i].found)
		{
			blocks[i].first = 0;
			blocks[i].var[0].back = blocks[i].var_c;
			blocks[i].var[blocks[i].var_c-1].next = blocks[i].var_c;
			for (j=1;j<blocks[i].var_c-1;j++)
			{
				blocks[i].var[j].back = j-1;
				blocks[i].var[j].next = j+1;
			}
		}
}
//=======================================================================
void cinput::no()
{
	FILE *f=fopen("block.out","wt");
	fprintf(f,"NO");
	fclose(f);
	exit(1);
}
//=======================================================================
void cinput::yes()
{
	int count=0;
	int i;
	for (i=1;i<101;i++)
		if (blocks[i].exist) count++;
	FILE *f=fopen("block.out","wt");
	fprintf(f,"%d\n",count);
	for (i=100;i>0;i--)
		if (blocks[i].exist)
			fprintf(f,"%d %d %d\n",blocks[i].var[blocks[i].f_var].x,blocks[i].var[blocks[i].f_var].y,i);
	fclose(f);
	exit(0);
}
//=======================================================================
void cinput::solve(int bind)
{
	if (solved) return;
	int bl=groups[cur_group].bl[bind].vis;
	if (blocks[bl].poseten) return;
	blocks[bl].poseten=1;
	int i,j,stop;
	for (i=0;i<blocks[bl].var_c;i++)
		if (test(blocks[bl].var[i].x, blocks[bl].var[i].y))
		{
			mark2(blocks[bl].var[i].x, blocks[bl].var[i].y,bl);
			blocks[bl].a_var=i;
			stop=0;
			for (j=0;j<groups[cur_group].count;j++)
				if (!blocks[groups[cur_group].bl[j].vis].poseten)
					solve(j);
				else stop++;
			if (stop == groups[cur_group].count) 
			{
				if (!solved)
				{
					printf("tup\n");
					int o,u;
					for (o=0;o<n;o++)
					{
						for (u=0;u<n;u++)
							printf("%3d",output[u][o]);
						printf("\n");
					}
						for (int p=0;p<groups[cur_group].count;p++)
							blocks[groups[cur_group].bl[p].vis].f_var = blocks[groups[cur_group].bl[p].vis].a_var;
				}
				solved = 1;
			}
			unmark(blocks[bl].var[i].x, blocks[bl].var[i].y);
		}
	blocks[bl].poseten=0;
}
void cinput::group_rec()
{
	solved = 1;
	int p;
	for (cur_group=0;cur_group<group_c;cur_group++)
	{
		solved = 0;
		solve(0);
		if (!solved) no();
		for (p=0;p<groups[cur_group].count;p++)
			printf("%d %d %d\n", groups[cur_group].bl[p].vis, blocks[groups[cur_group].bl[p].vis].var[blocks[groups[cur_group].bl[p].vis].f_var].x, blocks[groups[cur_group].bl[p].vis].var[blocks[groups[cur_group].bl[p].vis].f_var].y);
		solved =0;
	}
	yes();
}
//=======================================================================
void cinput::add_group(int ind)
{
	if (blocks[ind].mark) return;
	int i,j;
	blocks[ind].mark = 1;
	groups[cur_group].bl[groups[cur_group].count++].vis = ind;
	for (i=0;i<blocks[ind].var_c;i++)
		for (j=0;j<blocks[ind].var[i].count;j++)
			add_group(blocks[ind].var[i].prech[j].bl);
}
//=======================================================================
void cinput::make_goups()
{
	group_c=cur_group=0;
	for (int i=1;i<101;i++)
		if (blocks[i].exist && !blocks[i].found && !blocks[i].mark)
		{
			add_group(i);
			cur_group++;
			group_c++;
		}
	cur_group=0;
}
//=======================================================================
void cinput::rem_free()
{
	int i,j,p,k,pr_b,pr_v,f,e;
	int temp[1000];
	int t_c;
	for (i=0;i<10000;i++)
		if ((var_id[i].bl)&&(blocks[var_id[i].bl].var[var_id[i].index].count==0) && (!blocks[var_id[i].bl].found))
		{
			t_c = 0;
			printf("block: %d\n",var_id[i].bl); 
			blocks[var_id[i].bl].found = 1;
			blocks[var_id[i].bl].var[0].x = blocks[var_id[i].bl].var[var_id[i].index].x;
			blocks[var_id[i].bl].var[0].y = blocks[var_id[i].bl].var[var_id[i].index].y;
			for (j=0;j<blocks[var_id[i].bl].var_c;j++)	//ZA VSICHKI VARIANTI NA BLOKA KOITO SUM NAMERIL
				for (p=0;p<blocks[var_id[i].bl].var[j].count;p++)//ZA DADEN VARIANT OT VSICKI VARIANTI NA KOITO PRECHI
				{//PREMAHVA SEBE SI
					f = 0;
					if (t_c == 19)
					{
						e=1;
					}
					for (k=0;k<t_c;k++)
						if (temp[k] == blocks[var_id[i].bl].var[j].prech[p].id) 
							f = 1;
					if (!f)	
							temp[t_c++] = blocks[var_id[i].bl].var[j].prech[p].id;
				}
			for (k=0;k<t_c;k++)
			{
				pr_b = var_id[temp[k]].bl;
				pr_v = var_id[temp[k]].index;
//				printf("pr_b:%d pr_v:%d", pr_b,pr_v); 
				for (e=0;e<blocks[pr_b].var[pr_v].count;e++)
					for(p=0;p<blocks[var_id[i].bl].var_c;p++)
						if (blocks[pr_b].var[pr_v].prech[e].id == blocks[var_id[i].bl].var[p].id)
							blocks[pr_b].var[pr_v].remove(e);
			}
			i=0;
		}
}
//=======================================================================
void cinput::set_conflicts()
{
	int i,j,p1,p2,p3,k1,k2,k3,count=0,t_c;
	cpretend matr[100][100];
	cconflict temp[400];
	for (i=1;i<101;i++)
		if (blocks[i].exist && !blocks[i].found)
			for (j=0;j<blocks[i].var_c;j++)
			{
				matr[blocks[i].var[j].y][blocks[i].var[j].x].bl=i;
				matr[blocks[i].var[j].y][blocks[i].var[j].x].index=j;
				matr[blocks[i].var[j].y][blocks[i].var[j].x].id=count;
				blocks[i].var[j].id=count;
				var_id[count].bl = i;
				var_id[count].index = j;
				count++;
			}
	char temp2[100][100];
	for (i=0;i<100;i++)
		for (j=0;j<100;j++)
		{
			temp2[i][j] = output[i][j];
			output[i][j] = 0;
		}
	for (i=0;i<count;i++)
	{
		mark(blocks[var_id[i].bl].var[var_id[i].index].x, blocks[var_id[i].bl].var[var_id[i].index].y,1);
		t_c=0;
		for (j=0;j<count;j++)
			if ((i!=j) && (var_id[i].bl!=var_id[j].bl))
				if (!test(blocks[var_id[j].bl].var[var_id[j].index].x,blocks[var_id[j].bl].var[var_id[j].index].y))
				{
					temp[t_c].bl=var_id[j].bl;
					temp[t_c].index=var_id[j].index;
					temp[t_c].id=j;
					t_c++;
				}
		blocks[var_id[i].bl].var[var_id[i].index].count = t_c;
		if (t_c) 
		{
			blocks[var_id[i].bl].var[var_id[i].index].prech = new cconflict[t_c];
			memcpy(blocks[var_id[i].bl].var[var_id[i].index].prech, temp, t_c*(sizeof(cconflict)));
		}
		unmark(blocks[var_id[i].bl].var[var_id[i].index].x, blocks[var_id[i].bl].var[var_id[i].index].y);
	}
	for (i=0;i<100;i++)
		for (j=0;j<100;j++)
			output[i][j] = temp2[i][j];
/*	for (i=0;i<n;i++)
	{
		if ((i-2*m+1)<0) k1=0;
		else k1=i-2*m+1;
		if ((i+m-1)>(n-1)) k2=n-1;
		else k2=i+m-1;
		for (j=0;j<n;j++)
		{
			if (!matr[i][j].bl) continue;
			if ((j-m+1)<0) p1=0;
			else p1=j-m+1;
			if ((j+m-1)>(n-1)) p2=n-1;
			else p2=j+m-1;
			count=0;
			for (k3=k1;k3<=k2;k3++)
				for (p3=p1;p3<=p2;p3++)
					if (matr[k3][p3].bl && (matr[i][j].bl!=matr[k3][p3].bl))
					{
						temp[count].bl=matr[k3][p3].bl;
						temp[count].id=matr[k3][p3].id;
						temp[count].index=matr[k3][p3].index;
						count++;
					}
			if (count) 
			{
				blocks[matr[i][j].bl].var[matr[i][j].index].prech = new cconflict[count];
				memcpy(blocks[matr[i][j].bl].var[matr[i][j].index].prech,temp, count*sizeof(cconflict));
			}
			blocks[matr[i][j].bl].var[matr[i][j].index].count = count;
		}
	}*/
}
//=======================================================================
void cinput::var_all()
{
	int i, j, p, k, nach, e;
	for (i=100;i>0;i--)
		if (blocks[i].exist && !blocks[i].found)
		{
			if (blocks[i].view[0].edge1 || blocks[i].view[0].edge2) 
			{// OT UG MOZE DA SE FIKSIRA
				nach = blocks[i].view[0].beg;
				if (blocks[i].view[0].edge2) 
					nach = blocks[i].view[0].end - m;
				if (blocks[i].view[1].len)
/*1*/			{// OT IZTOK SE VIZDA
					p = (m-blocks[i].view[1].len+1);
					blocks[i].create(p);
					k = blocks[i].view[1].end - m;
					for (j=0,e=0;j<p;j++)
						if (test(nach, k+j))
						{
							blocks[i].var[e].x = nach;
							blocks[i].var[e++].y = k + j;
						}
					blocks[i].var_c = e;
				}
				else 
/*2*/			{// OT IZTOK NE SE VIZDA
					blocks[i].var_c = 1 - m;
					for (j=0;j<100;j++)
						if (input[1][j]>i)
							blocks[i].var_c++;
					blocks[i].create(blocks[i].var_c);
					for (j=0,e=0,k=1;j<100;j++)
						if (input[1][j]>i)
							if (++k>m)
								if (test(nach, j-m+1))
								{
 									blocks[i].var[e].x = nach; 
									blocks[i].var[e++].y = j - m + 1;
								}
								else ;
							else ;
						else k = 1;
					blocks[i].var_c = e;
				}
			}
			else // OT UG NE MOZE DA SE FIKSIRA
/*3*/			if (blocks[i].view[0].len) // OT UG SE VIZDA, NO NE MOZE DA SE FIKSIRA
					if (blocks[i].view[1].edge1 || blocks[i].view[1].edge2) 
					{// OT IZTOK MOZE DA SE FIKSIRA
						nach = blocks[i].view[1].beg;
						if (blocks[i].view[1].edge2)
							nach = blocks[i].view[1].end - m;
						p = (m-blocks[i].view[0].len+1);
						blocks[i].create(p);
						k = blocks[i].view[0].end - m;
						for (j=0, e=0;j<p;j++)
							if (test(k+j, nach))
							{
								blocks[i].var[e].x = k + j;
								blocks[i].var[e++].y = nach;
							}
						blocks[i].var_c = e;
					}
					else
						if (blocks[i].view[1].len)
/*4*/					{//OT IZTOK SE VIZDA, NO NE MOZE DA SE FIKSIRA
							blocks[i].create((m-blocks[i].view[0].len+1)*(m-blocks[i].view[1].len+1));
							nach = blocks[i].view[0].end - m;
							k = blocks[i].view[1].end - m;
							for (e=0,j=0;j<(m-blocks[i].view[0].len+1);j++)
								for (p=0;p<(m-blocks[i].view[1].len+1);p++)
									if (test(nach+j,k+p))
									{
										blocks[i].var[e].x = nach+j;
										blocks[i].var[e++].y = k+p;
									}
							blocks[i].var_c = e;
						}
						else
/*5*/					{//OT IZTOK NE SE VIZDA, OT UG SAMO SE VIZDA
							for (j=0;j<100;j++)
								if (input[1][j]>i)
									blocks[i].var_c++;
							blocks[i].create((blocks[i].var_c - m + 1)*(m-blocks[i].view[0].len+1));
							nach = blocks[i].view[0].end - m;
							for (k=1, e=0, j=0;j<100;j++)
								if (input[1][j]>i)
									if (++k>m)
										for (p=0;p<(m-blocks[i].view[0].len+1);p++)
											if (test(p+nach,j-m+1))
											{
												blocks[i].var[e].x = p+nach;
												blocks[i].var[e++].y = j-m+1;
											}
											else ;
									else ;
								else k=1;
							blocks[i].var_c = e;
						}
				else//OT UG NE SE VIZDA
					if (blocks[i].view[1].edge1 || blocks[i].view[1].edge2)
/*6*/				{//OT IZTOK MOZE DA SE FIKSIRA
						nach = blocks[i].view[1].beg;
						if (blocks[i].view[1].edge2) 
						nach = blocks[i].view[1].end - m;
						for (j=0;j<100;j++)
							if (input[0][j]>i)
								blocks[i].var_c++;
						blocks[i].create(blocks[i].var_c - m + 1);
						for (k=1, j=0,  p=0;j<100;j++)
							if (input[0][j]>i)
							{
								if (++k>m)
									if (test(j-m+1,nach))
									{
										blocks[i].var[p].x = j-m+1; 
										blocks[i].var[p++].y = nach;
									}
							}
							else k = 1;
						blocks[i].var_c=p;
					}
					else
/*7*/				{//OT IZTOK NE MOZE DA SE FIKSIRA, NO SE VIZDA OT UG NE SE VIZDA
						for (j=0;j<100;j++)
							if (input[0][j]>i)
								blocks[i].var_c++;
						blocks[i].create((blocks[i].var_c - m + 1)*(m-blocks[i].view[1].len+1));
						nach = blocks[i].view[1].end - m;
						for (k=1, e=0, j=0;j<100;j++)
							if (input[0][j]>i)
								if (++k>m)
									for (p=0;p<(m-blocks[i].view[0].len+1);p++)
										if (test(j-m,p+nach))
										{
											blocks[i].var[e].x = j - m;
											blocks[i].var[e++].y = p + nach;
										}
										else ;
								else ;
							else k=1;
						blocks[i].var_c=e;
					}
		}
}
//=======================================================================
void cinput::rem_fix()
{
	int i, stop, j;
	do
	{
		stop=0;
		for (i=100;i>0;i--)
			if (blocks[i].exist)
				if (blocks[i].var_c==1&&!blocks[i].found)
				{
					mark(blocks[i].var[0].x, blocks[i].var[0].y,i);
					blocks[i].found=1;
					stop=1;
				}
		for (i=1;i<101;i++)
			if  (blocks[i].exist && !blocks[i].found)
				for (j=0;j<blocks[i].var_c;j++)
					if (!test(blocks[i].var[j].x, blocks[i].var[j].y))
					{
						blocks[i].remove(j);
						j=0;
					}
	}while(stop);

}
//=======================================================================
void cinput::mark(char x, char y, char bl)
{
	if (test(x,y))
		for (char i = x+m-1;i>=x;i--)
			memset(output[i] + y, bl, m);
}
void cinput::mark2(char x, char y, char bl)
{
	for (char i = x+m-1;i>=x;i--)
		memset(output[i] + y, bl, m);
}
void cinput::unmark(char x, char y)
{
	for (char i = x+m-1;i>=x;i--)
		memset(output[i] + y, 0, m);
}
//=======================================================================
int cinput::test(char x, char y)
{
	if (output[x][y] || output[x][y+(m-1)] || output[x+m-1][y] || output[x+m-1][y+m-1])
		return 0;
	return 1;
}
//=======================================================================
void cinput::mark_good()
{
	int i=100, x, y;
	for (;i>0;i--)
		if ((blocks[i].view[0].edge1 || blocks[i].view[0].edge2) && (blocks[i].view[1].edge1 || blocks[i].view[1].edge2))
		{
			x = blocks[i].view[0].beg;
			y = blocks[i].view[1].beg;
			if (blocks[i].view[0].edge2) 
				x = blocks[i].view[0].end - m;
			if (blocks[i].view[1].edge2)
				y = blocks[i].view[1].end - m;
			mark(x, y,i);
			blocks[i].create(1);
			blocks[i].var[0].x = x;
			blocks[i].var[0].y = y;
			blocks[i].found = 1;
		}
}
//=======================================================================
cinput::cinput(char * fname)
{
	FILE *f = fopen(fname,"rt");
	group_c=cur_group=0;
	int i=0, j, h = 0, h2;
	fscanf(f,"%d%d",&n,&m);
	for (;i<n;i++)
		for (j=0;j<n;j++)
			output[i][j] = 0;
	for (i=0;i<n;i++)
	{
		h2 = h;
		fscanf(f, "%d", &h);
		input[0][i] = h;
		if (h2!=h) 
		{
			if (h2<h)
				blocks[h].view[0].edge1 = 1;
			else 
				blocks[h2].view[0].edge2 = 1;
			blocks[h].exist = 1;
			blocks[h2].view[0].end = blocks[h].view[0].beg = i;
			blocks[h2].view[0].len = blocks[h2].view[0].end - blocks[h2].view[0].beg;
		}
	}
	blocks[h].view[0].edge2 = 1;
	blocks[h].view[0].end = n;
	h=0;
	for (i=0;i<n;i++)
	{
		h2 = h;
		fscanf(f, "%d", &h);
		input[1][i] = h;
		if (h2!=h) 
		{
			if (h2<h)
				blocks[h].view[1].edge1 = 1;
			else 
				blocks[h2].view[1].edge2 = 1;
			blocks[h].exist = 1;
			blocks[h2].view[1].end = blocks[h].view[1].beg = i;
			blocks[h2].view[1].len = blocks[h2].view[1].end - blocks[h2].view[1].beg;
		}
	}
	blocks[h].view[1].edge2 = 1;
	blocks[h].view[1].end = n;
	blocks[0].exist=0;
} 
//=======================================================================
//=======================================================================
main()
{
	cinput input("block.in");
	input.mark_good();
	input.var_all();
	int i,j;
	for (i=100;i>0;i--)
	{
		if (input.blocks[i].exist)
			for (j=0;j<input.blocks[i].var_c;j++)
				printf("bl:%d var:%d x:%d y:%d\n",i,j+1,input.blocks[i].var[j].x,input.blocks[i].var[j].y);
	}
	input.rem_fix();
	input.set_conflicts();
	input.make_goups();
	input.group_rec();
}