#include <fstream.h>

struct Block {
	int x;
	int y;
	int height;
};

const char inputFileName[] = "BLOCK.IN";
const char outputFileName[] = "BLOCK.OUT";

unsigned int blockMap [101];
unsigned int blockCount = 0;

unsigned int N, M;

unsigned int * southView;
unsigned int * eastView;

Block * blocks;


int readData() {
	fstream inputFile(inputFileName, ios::in);

	inputFile >> N;
	inputFile >> M;

	if (!(eastView = new unsigned int[N])) {
		cout << "Not enough memory! Buy more!";
		return 1;
	}

	if(!(southView = new unsigned int[N])) {
		cout << "Not enough memory! Buy more!";
	}

	for (int i=0; i<N; i++) {
		inputFile >> eastView[i];
		if (eastView[i] && !(blockMap[eastView[i]]++)) {
			blockCount ++;
		}
	}

	for (i=0; i<N; i++) {
		inputFile >> southView[i];
		if (southView[i] && !(blockMap[southView[i]]++)) {
			blockCount ++;
		}
	}

	blocks = new Block[blockCount];
	for (i=0; i<blockCount; i++) {
		blocks[i].x = -1;
		blocks[i].y = -1;
		blocks[i].height = -1;
	}

	int cnt = 0;
	for (i=1; i<101; i++) {
		if (blockMap[i]) {
			blocks[cnt++].height = i;
		}
	}

	inputFile.close();
	return 0;
}

void parseViews() {
	for (int i=0; i<blockCount; i++) {
		for (int j=0; j<N; j++) {
			if(eastView[j] == blocks[blockCount-i-1].height) {
				if ((eastView[j-1]<blocks[blockCount-i-1].height) || (j<M)) {
					int widthCnt = 0;

					for (int p=j-1; p>j-M; p--) {
						if (eastView[p] == blocks[blockCount-i-1].height) {
							widthCnt++;
						}
					}

					if (widthCnt == 0) {
						blocks[blockCount-i-1].x = j;
					} else {
						blocks[blockCount-i-1].x = j - M + widthCnt;
					}
					break;
				} else {
					// blocks[blockCount-i-1].x = -1;
					int widthCnt = 0;

					for (int p=j; p<j+M; p++) {
						if (eastView[p] == blocks[blockCount-i-1].height) {
							widthCnt++;
						} else {
							break;
						}
					}

					if (widthCnt == M) {
						blocks[blockCount-i-1].x = j;
					} else {

						if ((eastView[p] < blocks[blockCount-i-1].height) || (p==N)) {
							blocks[blockCount-i-1].x = p - M;
						} else {
							blocks[blockCount-i-1].x = j;
						}
					}

					break;
				}
			}
		}

		for (j=0; j<N; j++) {
			if(southView[j] == blocks[blockCount-i-1].height) {
				if ((southView[j-1]<blocks[blockCount-i-1].height) || (j<M)) {
					int widthCnt = 0;

					for (int p=j-1; p>j-M; p--) {
						if (southView[p] == blocks[blockCount-i-1].height) {
							widthCnt++;
						}
					}

					if (widthCnt == 0) {
						blocks[blockCount-i-1].y = j;
					} else {
						blocks[blockCount-i-1].y = j - M + widthCnt;
					}

					break;
				} else {
					//blocks[blockCount-i-1].y = -1;
					int widthCnt = 0;

					for (int p=j; p<j+M; p++) {
						if (southView[p] == blocks[blockCount-i-1].height) {
							widthCnt++;
						} else {
							break;
						}
					}

					if (widthCnt == M) {
						blocks[blockCount-i-1].y = j;
					} else {
						if ((southView[p] < blocks[blockCount-i-1].height)|| (p==N)) {
							blocks[blockCount-i-1].y = p - M;
						} else {
							blocks[blockCount-i-1].y = j;
						}
					}

					break;
				}
			}
		}
	}
}

int doesColide(int a, int b) {
	if ( ((blocks[b].x > blocks[a].x - M) && (blocks[b].x < blocks[a].x + M)) &&
		 ((blocks[b].y > blocks[a].y - M) && (blocks[b].y < blocks[a].y + M))
	   ) {
		   return 1;
	   } else {
		   return 0;
	   }
}

void findFinalPlacement() {
	// by x

	for (int i=0; i<blockCount; i++) {
		if (blocks[blockCount-i-1].x == -1) {

			for (int j=0; j<blockCount; j++) {

				if (blocks[j].height > blocks[blockCount-i-1].height) {
					int tempx = blocks[blockCount-i-1].x;
					blocks[blockCount-i-1].x = blocks[j].x;

					for (int p=0; p<blockCount; p++) {

						if (doesColide(blockCount-i-1, p) && (blockCount-i-1!=p)) {
							blocks[blockCount-i-1].x = tempx;
							break;
						}

					}

					if (blocks[blockCount-i-1].x != tempx) {
						break;
					}

				}

			}

		}
	}

	// by y

	for (i=0; i<blockCount; i++) {
		if (blocks[blockCount-i-1].y == -1) {

			for (int j=0; j<blockCount; j++) {

				if (blocks[j].height > blocks[blockCount-i-1].height) {
					int tempy = blocks[blockCount-i-1].y;
					blocks[blockCount-i-1].y = blocks[j].y;

					for (int p=0; p<blockCount; p++) {

						if (doesColide(blockCount-i-1, p) && (blockCount-i-1!=p)) {
							blocks[blockCount-i-1].y = tempy;
							break;
						}

					}

					if (blocks[blockCount-i-1].y != tempy) {
						break;
					}

				}

			}

		}
	}
}

void writeData() {
	fstream outputFile(outputFileName, ios::out);

	int flag = 0;

	for (int i=0; i<blockCount; i++) {
		if ((blocks[i].x == -1) || (blocks[i].y == -1)) {
			outputFile << 'NO';
			flag = 1;
		}
	}

	if (!(flag)) {
		for (i=0; i<blockCount; i++) {
			for (int j=0; j<blockCount; j++) {
				if ((i!=j) && doesColide(i, j)) {
					flag = 1;
					break;
				}
			}
		}
	}

	if (!(flag)) {
	   outputFile << blockCount << '\n';
	   for (int i=0; i<blockCount; i++) {
		   outputFile << blocks[i].x << ' ' << blocks[i].y << ' ' << blocks[i].height << '\n';
	   }
	}
	outputFile.close();
}

void main() {
	readData();
	parseViews();
	findFinalPlacement();
	writeData();

	if (southView) delete southView;
	if (eastView) delete eastView;
	if (blocks) delete blocks;
}