//  2
// m_roussev@yahoo.com
//    / 29 . / .  /  


#include <vector>
#include <fstream>
#include <sstream>
#include <valarray>

using namespace std;

const int PROGRAM_ERROR_NO_ERROR = 0;
const int PROGRAM_ERROR_CANNOT_OPEN_INPUT_FILE = 1;
const int PROGRAM_ERROR_CANNOT_CREATE_OUTPUT_FILE = 2;
const int PROGRAM_ERROR_INPUT_DATA_OUT_OF_RANGE = 3;


const string FILE_NAME_INPUT = "BLOCK.IN";
const string FILE_NAME_OUTPUT = "BLOCK.OUT";


const int N_MIN = 1;
const int N_MAX = 100;
const int M_MIN = 1;
const int M_MAX = 10;
const int H_MIN = 0;
const int H_MAX = 100;

class Point
{
 public:
  int x;
  int y;
  Point(const int x_coor, const int y_coor)
  {
    x = x_coor;
    y = y_coor;
  };
}; // class Point


class Res_Block
{
 public:
  int h;
  int x;
  int y;
  Res_Block(const int v, const int x_coor, const int y_coor)
  {
    h = v;
    x = x_coor;
    y = y_coor;
  };
  bool operator< (const Res_Block& a_res) const
  {
   return ( this->h < a_res.h  );
  };
}; // class Res_Block



class Block
{
public:
  int h; // 
  Block(const int h)
  {
   this->h = h;
   count = 0;
  };
  void AddCertainXY(const int x_coor, const int y_coor);
  void AddPossibleXY(const int x_coor, const int y_coor);
  bool IsInCertainXY(const int x_coor, const int y_coor, const int m);
  void DetermineMargins(const int n, const int m);
  inline bool IsBlockDone();
  size_t GetPossibleXYSize() const
  {
    return PossibleXY.size();
  };
  void SetToFirst()
  {
    it_possible =  PossibleXY.begin();
    it_end = PossibleXY.end();
  };
  bool IsCertainXYEmpty()
  {
    return (CertainXY.empty()) ;
  };
  int min_x;
  int max_x;
  int min_y;
  int max_y;
  int count;
  vector<Point>::iterator it_possible;
  vector<Point>::iterator it_end;
private:
  vector<Point> CertainXY;
  vector<Point> PossibleXY;
}; // class Block

void Block::AddCertainXY(const int x_coor, const int y_coor)
{
  Point aPoint(x_coor, y_coor);
  CertainXY.push_back( aPoint );
} // void Block::AddCertainXY(const int x_coor, const int y_coor)

void Block::AddPossibleXY(const int x_coor, const int y_coor)
{
  Point aPoint(x_coor, y_coor);
  PossibleXY.push_back( aPoint );
}
bool Block::IsInCertainXY(const int x_coor, const int y_coor, const int m)
{
  bool result = false;
  for ( size_t i = 0; i<CertainXY.size(); i++  )
    if ( x_coor<=CertainXY[i].x && CertainXY[i].x<=x_coor+m-1 && y_coor<=CertainXY[i].y && CertainXY[i].y<=y_coor+m-1 )
      return true;
  return result;
}

void Block::DetermineMargins(const int n, const int m)
{
  if ( CertainXY.empty() )
  {
    min_x = 0;
    max_x = n-1;
    min_y = 0;
    max_y = n-1;
  }
  else
  {
    int min_xx = n-1;
    int max_xx = 0;
    int min_yy = n-1;
    int max_yy = 0;
    for ( size_t i=0; i< CertainXY.size(); i++)
    {
      if ( min_xx > CertainXY[i].x )
        min_xx = CertainXY[i].x;
      if ( max_xx < CertainXY[i].x )
        max_xx = CertainXY[i].x;
      if ( min_yy > CertainXY[i].y )
        min_yy = CertainXY[i].y;
      if ( max_yy < CertainXY[i].y )
        max_yy = CertainXY[i].y;
    };
    min_x = max_xx - m + 1;
    max_x = min_xx + m - 1;
    min_y = max_yy - m + 1;
    max_y = min_yy + m - 1;

    if ( min_x < 0 )
      min_x = 0;
    if ( max_x > n-1 )
      max_x = n-1;
    if ( min_y < 0 )
      min_y = 0;
    if ( max_y > n-1 )
      max_y = n-1;
  };
} // void Block::DetermineMargins()

inline bool Block::IsBlockDone()
{
  return ( !PossibleXY.empty() ) ;
} // inline bool Block::IsBlockDone()


bool ComparePossibleXYSize( const Block& a_block1, const Block& a_block2)
{
  return ( a_block1.GetPossibleXYSize() < a_block2.GetPossibleXYSize() ) ;
};




class Blocks
{
public:
  Blocks(const int NN, const int MM);
  Blocks(Blocks& parent);
  void AddBlock(const int h);
  void AddBlockWithCertrainXY(const int x_coor, const int y_coor, const int h);
inline void SetXYValue(const int x_coor, const int y_coor, const int value);
  void DeterminePosibleXY();
  inline bool IsAllBlockDone();
  bool IsValidVariant();
  ~Blocks();
//  BlockList aBlockList;
  vector<Res_Block> a_result;
private:
  int n; //   
  int m; //   
  valarray<int>* max_h; //      
  vector<Block> block_list; //   

}; //class Block

bool Blocks::IsValidVariant()
{
  if ( !IsAllBlockDone() )
    return false;

  //         
  sort( block_list.begin(), block_list.end(), ComparePossibleXYSize);

  vector<Block>::iterator it_block_list;
  vector<Block>::iterator it_save_block_list;

  it_block_list = block_list.begin();
  it_block_list->SetToFirst();

  while ( true )
  {
    it_save_block_list = it_block_list;
    bool not_exists = true ;
    while ( it_save_block_list != block_list.begin() && not_exists )
    {
      it_save_block_list-- ;

      if (
           abs( it_save_block_list->it_possible->x - it_block_list->it_possible->x ) < m
           &&
           abs( it_save_block_list->it_possible->y - it_block_list->it_possible->y ) < m
          )
        not_exists = false ;
    }; // while



    if ( not_exists )
    {
      it_block_list++ ;
      if ( it_block_list == block_list.end() )
      {
        //    
        for ( it_block_list = block_list.begin(); it_block_list != block_list.end(); it_block_list++ )
        {
          Res_Block a_res(it_block_list->h, it_block_list->it_possible->x, it_block_list->it_possible->y);
          a_result.push_back(a_res);
        };

        sort( a_result.begin(), a_result.end() );
        return true;
      }
      else
      {
        it_block_list->SetToFirst();
      };

    } // if not_exists
    else
    {
      do
      {
        it_block_list->it_possible++ ;
        if ( it_block_list->it_possible == it_block_list->it_end )
        {
          if ( it_block_list == block_list.begin() )
          {
            return false;
          }
          else
          {
            it_block_list-- ;
          };
        }
        else
        {
          break;
        };
      }
      while ( true );
    }; // else exists
  }; // while true

} // void Blocks::SortBlocks()

void Blocks::DeterminePosibleXY()
{
  for (size_t index = 0; index < block_list.size(); index++)
  {
    int block_v = block_list[index].h;
    block_list[index].DetermineMargins(n,m);


    for (int x=block_list[index].min_x; x<=block_list[index].max_x-m+1; x++)
      for (int y=block_list[index].min_y; y<=block_list[index].max_y-m+1; y++)
      {
        bool flag = true;
        for ( int xx=x; ( xx< x + m ) && flag; xx++  )
          for ( int yy=y; yy<y+m; yy++ )
            if ( (*max_h)[yy*n + xx] < block_v )
              {
                flag = false;
                break;
              };
        if ( flag )
        {
          bool flag_exists = false;
          for (size_t index2 = 0; index2 < block_list.size(); index2++)
            if ( index2 != index )
              if ( block_list[index2].IsInCertainXY(x, y, m) )
              {
                flag_exists = true;
                break;
              };
          if ( !flag_exists )
          {
            if ( block_list[index].IsCertainXYEmpty() )
            {
              int counter_vl = 0;
              for ( int xx=x; ( xx< x + m ) ; xx++  )
                for ( int yy=y; yy<y+m; yy++ )
                  if ( (*max_h)[yy*n + xx] == block_v )
                    counter_vl++;

              if ( counter_vl == (block_list[index].count*m) )
                block_list[index].AddPossibleXY(x, y) ;
            }
            else
              block_list[index].AddPossibleXY(x, y) ;
          };

        }; // if flag

      }; // for x, y

  }; // for (size_t index = 0; index<block_list.size(); index++)



} // void Blocks::DeterminePosibleXY()

Blocks::Blocks(const int NN, const int MM)
{
  n = NN ;
  m = MM ;
  max_h = new valarray<int>(n*n);
}  // Blocks::Blocks(const int NN, const int MM)

Blocks::Blocks( Blocks& parent)
{
  n = parent.n ;
  m = parent.m ;

  max_h = new valarray<int>( *parent.max_h );
}  // Blocks::Blocks( Blocks& parent)

void Blocks::AddBlock( const int h )
{
 //    
 size_t index ;
 for ( index=0; index<block_list.size(); index++ )
   if ( block_list[index].h == h )
     break;

 if ( index==block_list.size() )
 {
   Block aBlock(h);
   block_list.push_back(aBlock);
 };

 block_list[index].count++;

} // void BlockList::AddBlock

void Blocks::AddBlockWithCertrainXY(const int x_coor, const int y_coor, const int h)
{
 //    
 vector<Block>::iterator it = block_list.begin();
 while ( it->h != h )
   it++;

 //   
 it->AddCertainXY(x_coor, y_coor);
} // void Blocks::AddBlockWithCertrainXY(const int x_coor, const int y_coor, const int h)




inline void Blocks::SetXYValue(const int x_coor, const int y_coor, const int value)
{
  (*max_h)[y_coor*n + x_coor] = value ;
} // void Blocks::SetXYValue(const int x_coor, const int y_coor, const int value)


Blocks::~Blocks()
{
  delete max_h;
}  // Blocks::~Blocks()

inline bool Blocks::IsAllBlockDone()
{
   for (size_t index = 0; index < block_list.size(); index++)
     if ( !block_list[index].IsBlockDone() )
       return false;

   return true;
}


//---------------------------------------------------------------------------
int main()
{
  ifstream data_input;  //  
  ofstream data_output; //  
  int N;  //   
  int M;  //   
  vector<int> SilSouth; //  
  vector<int> SilEast;  //  

  Blocks* some_blocks;

  { //    

    data_input.open (FILE_NAME_INPUT.c_str(), ios::in);
    if ( data_input.fail() )
    {
      cerr << "PROGRAM_ERROR_CANNOT_OPEN_INPUT_FILE " << FILE_NAME_INPUT << endl;

      return PROGRAM_ERROR_CANNOT_OPEN_INPUT_FILE ;
    };

    string input_line;

    getline(data_input, input_line);
    istringstream sNM(input_line);

    getline(data_input, input_line);
    istringstream sSilS(input_line);

    getline(data_input, input_line);
    istringstream sSilE(input_line);

    data_input.close();


    sNM >> N >> M ;

    if ( (N<N_MIN) || (N>N_MAX) || (M<M_MIN) || (M>M_MAX))
    {
      cerr << "PROGRAM_ERROR_INPUT_DATA_OUT_OF_RANGE" << endl;

      return PROGRAM_ERROR_INPUT_DATA_OUT_OF_RANGE ;
    };

    //   
    for (int i=0; i<N; i++)
    {
      int x;
      int y;

      x = H_MAX + 1;
      y = H_MAX + 1;
      sSilS >> x;
      sSilE >> y;

      if ( (x<H_MIN) || (x>H_MAX) || (y<H_MIN) || (y>H_MAX))
      {
        cerr << "PROGRAM_ERROR_INPUT_DATA_OUT_OF_RANGE" << endl;

        return PROGRAM_ERROR_INPUT_DATA_OUT_OF_RANGE ;
      };

      SilSouth.push_back(x);
      SilEast.push_back(y);
    }; // for

  };//    


  //    
  some_blocks = new Blocks (N,M);
  {
    { //     
      bool flag0 = true;
      for ( int i=0; i<N; i++ )
      {
        if ( SilSouth[i] != H_MIN )
        {
          some_blocks->AddBlock( SilSouth[i] );
          flag0 = false;
        }; // if SilSouth[i]

        if ( SilEast[i] != H_MIN )
        {
          some_blocks->AddBlock( SilEast[i] );
          flag0 = false;
        }; // if SilEast[i]
      };  // for

    if ( flag0 )
    {
      data_output.open (FILE_NAME_OUTPUT.c_str(), ios::trunc | ios::out );
      if ( data_output.fail() )
      {
        cerr << "PROGRAM_ERROR_CANNOT_CREATE_OUTPUT_FILE " << FILE_NAME_OUTPUT << endl;
        return PROGRAM_ERROR_CANNOT_CREATE_OUTPUT_FILE ;
      };
     data_output << "0" ;
     data_output.close();
     return PROGRAM_ERROR_NO_ERROR;
    };

    };

    for (int x=0; x<N; x++)
      for (int y=0; y<N; y++)
      {
        int min_h = min(SilSouth[x], SilEast[y]);
        some_blocks->SetXYValue(x, y, min_h);
        if ( (SilSouth[x] == SilEast[y]) && (SilSouth[x]!=H_MIN))
          some_blocks->AddBlockWithCertrainXY(x, y, min_h);
      }; //for x, y
  };

 some_blocks->DeterminePosibleXY();

 data_output.open (FILE_NAME_OUTPUT.c_str(), ios::trunc | ios::out );
 if ( data_output.fail() )
 {
   cerr << "PROGRAM_ERROR_CANNOT_CREATE_OUTPUT_FILE " << FILE_NAME_OUTPUT << endl;
    return PROGRAM_ERROR_CANNOT_CREATE_OUTPUT_FILE ;
 };

 if (some_blocks->IsValidVariant())
 {
   data_output << some_blocks->a_result.size() << endl;
   for ( size_t i=0; i<some_blocks->a_result.size(); i++  )
   {
     data_output << some_blocks->a_result[i].x << " "
                 << some_blocks->a_result[i].y << " "
                 << some_blocks->a_result[i].h << endl;
   };
 }
 else
 {
   data_output << "NO" ;
 };

 data_output.close();

 delete some_blocks;

 return PROGRAM_ERROR_NO_ERROR;
} // int main()


