#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_N 100
#define MAX_M 10

typedef struct { int x, y, h; } block;

typedef struct { int sx, s_cnt, ex, e_cnt; } h_pos;
typedef struct { int h; h_pos p; } height;

int n, m;
int south[MAX_N], east[MAX_N];
int south_cov[MAX_N], east_cov[MAX_N];
int south_cov_stack[MAX_N][MAX_M], east_cov_stack[MAX_N][MAX_M];
height * heights[MAX_N]; int heights_cnt;
int height_covered[MAX_N];

int map[MAX_N][MAX_N];
block blocks[MAX_N]; int block_cnt;

int init_heights( void )
{
   int i, j, h, t, tj; height * temp;

   for ( i = 0; i < n; i++ )
   {
      if ( h = south[i] )
      {
         for ( j = 0; j < heights_cnt; j++ )
            if ( heights[j]->h == h ) goto L2;

         j = heights_cnt++;

         heights[j] = (height *) malloc( sizeof(height) );
         heights[j]->h = h;
         heights[j]->p.s_cnt = heights[j]->p.e_cnt = 0;
         
L2:
         if ( heights[j]->p.s_cnt )
         {
            if ( heights[j]->p.sx + heights[j]->p.s_cnt != i ) return 0;
            heights[j]->p.s_cnt++;
         }
         else
         {
            heights[j]->p.sx = i; heights[j]->p.s_cnt = 1;
         }
      }

      if ( h = east[i] )
      {
         for ( j = 0; j < heights_cnt; j++ )
            if ( heights[j]->h == h ) goto L3;

         j = heights_cnt++;
         
         heights[j] = (height *) malloc( sizeof(height) );
         heights[j]->h = h;
         heights[j]->p.s_cnt = heights[j]->p.e_cnt = 0;

L3:
         if ( heights[j]->p.e_cnt )
         {
            if ( heights[j]->p.ex + heights[j]->p.e_cnt != i ) return 0;
            heights[j]->p.e_cnt++;
         }
         else
         {
            heights[j]->p.ex = i; heights[j]->p.e_cnt = 1;
         }         
      }
   }

   for ( i = 0; i < heights_cnt - 1; i++ )
   {
      h = heights[i]->h; t = heights[ tj = i + 1 ]->h;
      for ( j = i + 1; j < heights_cnt; j++ )
         if ( heights[j]->h > t ) { t = heights[ tj = j ]->h; }

      if ( t > h )
      {
         temp = heights[tj];
         heights[tj] = heights[i];
         heights[i] = temp;
      }
   }

   return 1;
}

int try_place( int tx, int ty, int h )
{
   int x, y;
   
   if ( ( south[tx] < h ) || ( east[ty] < h ) ) return 0;

   for ( y = ty; y < ty + m; y++ )
   {
      for ( x = tx; x < tx + m; x++ )
      {
         if ( map[y][x] || (south[x] < h) || (east[y] < h) ) return 0;
      }
   }

   return 1;
}

int try_place_y( int tx, int ty, int h )
{
   int x, y = ty + m - 1;
   
   if ( ( south[tx] < h ) || ( east[y] < h ) ) return 0;

   for ( x = tx; x < tx + m; x++ )
      if ( map[y][x] || (south[x] < h) ) return 0;

   return 1;
}

void place_block( int tx, int ty, int h, int level )
{
   int x, y;
   
   blocks[level].x = tx;
   blocks[level].y = ty;
   blocks[level].h = h;

   for ( y = ty; y < ty + m; y++ )
      for ( x = tx; x < tx + m; x++ )
         map[y][x] = 1;

   for ( x = tx; x < tx + m; x++ )
      if ( h > south_cov[x] ) south_cov[x] = h;
      
   for ( y = ty; y < ty + m; y++ )
      if ( h > east_cov[y] ) east_cov[y] = h;
}

void move_block_y( int level )
{
   int x, y, h; int tx, ty;

   tx = blocks[level].x;
   ty = blocks[level].y++;
   h = blocks[level].h;

   for ( x = tx; x < tx + m; x++ )
   {
      map[ty][x] = 0;
      map[ty + m][x] = 1;
   }
   
   for ( x = tx; x < tx + m; x++ )
      if ( h > south_cov[x] ) south_cov[x] = h;

   ty++;

   for ( y = ty; y < ty + m; y++ )
      if ( h > east_cov[y] ) east_cov[y] = h;
}

void remove_last_block( int level )
{
   int x, y, tx, ty;
   
   tx = blocks[level].x;
   ty = blocks[level].y;

   for ( y = ty; y < ty + m; y++ )
      for ( x = tx; x < tx + m; x++ )
         map[y][x] = 0;
}

int greedy( int k )
{
   int i;
   
   if ( k == heights_cnt )
   {
      for ( i = 0; i < n; i++ )
        if ( ( south[i] != south_cov[i] ) ||
             ( east[i] != east_cov[i] ) ) return 0;

      return 1;
   }
   if ( height_covered[k] )
   {
      return greedy( k + 1 );
   }
   else
   {
      int st, stm, et, etm;
      int s, e;
      int h, p;
      int flag, __flag;
   
      h = heights[k]->h;

      if ( p = heights[k]->p.s_cnt )
      {
         st = heights[k]->p.sx - m + p;
         if (st < 0) st = 0;
         
         stm = heights[k]->p.sx + m - p;
         if (stm >= n) stm = n - 1;
      }
      else { st = 0; stm = n - 1; }

      if ( p = heights[k]->p.e_cnt )
      {
         et = heights[k]->p.ex - m + p;
         if (et < 0) et = 0;
         
         etm = heights[k]->p.ex + m - p;
         if (etm >= n) etm = n - 1;
      }
      else { et = 0; etm = n - 1; }
         
      if ( heights[k]->p.s_cnt || heights[k]->p.e_cnt )
      {
         for ( s = st; s <= stm; s++ )
         {
            flag = __flag = 0;
            for ( e = et; e <= etm; e++ )
            {
               if ( !flag )
               {
                  if ( try_place( s, e, h ) )
                  {
                     flag = 1;
                     memcpy( south_cov_stack[k], south_cov + s, sizeof(int)*m );
                     memcpy( east_cov_stack[k], east_cov + e, sizeof(int)*m );
                        
                     place_block( s, e, h, k );
                     if ( greedy( k + 1 ) ) return 1;
                     __flag = 1;

                     memcpy( south_cov + s, south_cov_stack[k], sizeof(int)*m );
                     memcpy( east_cov + e, east_cov_stack[k], sizeof(int)*m );
                  }
               }
               else
               {
                  if ( try_place_y( s, e, h ) )
                  {
                     memcpy( south_cov_stack[k], south_cov + s, sizeof(int)*m );
                     memcpy( east_cov_stack[k], east_cov + e, sizeof(int)*m );
                        
                     move_block_y(k);
                     if ( greedy( k + 1 ) ) return 1;
                     __flag = 1;

                     memcpy( south_cov + s, south_cov_stack[k], sizeof(int)*m );
                     memcpy( east_cov + e, east_cov_stack[k], sizeof(int)*m );                  
                  }
                  else
                  {
                     flag = 0;
                   //  if ( __flag ) { remove_last_block(k); __flag = 0; }
                   // difference from recursia()
                  }
               }
            }

            if ( __flag ) { remove_last_block(k); __flag = 0; }
         }
      }
   }

   return 0;
}

int recursia( int k )
{
   int i;
   
   if ( k == heights_cnt )
   {
      for ( i = 0; i < n; i++ )
        if ( ( south[i] != south_cov[i] ) ||
             ( east[i] != east_cov[i] ) ) return 0;

      return 1;
   }
   if ( height_covered[k] )
   {
      return recursia( k + 1 );
   }
   else
   {
      int st, stm, et, etm;
      int s, e;
      int h, p;
      int flag, __flag;
   
      h = heights[k]->h;

      if ( p = heights[k]->p.s_cnt )
      {
         st = heights[k]->p.sx - m + p;
         if (st < 0) st = 0;
         
         stm = heights[k]->p.sx + m - p;
         if (stm >= n) stm = n - 1;
      }
      else { st = 0; stm = n - 1; }

      if ( p = heights[k]->p.e_cnt )
      {
         et = heights[k]->p.ex - m + p;
         if (et < 0) et = 0;
         
         etm = heights[k]->p.ex + m - p;
         if (etm >= n) etm = n - 1;
      }
      else { et = 0; etm = n - 1; }
         
      if ( heights[k]->p.s_cnt || heights[k]->p.e_cnt )
      {
         for ( s = st; s <= stm; s++ )
         {
            flag = __flag = 0;
            for ( e = et; e <= etm; e++ )
            {
               if ( !flag )
               {
                  if ( try_place( s, e, h ) )
                  {
                     flag = 1;
                     memcpy( south_cov_stack[k], south_cov + s, sizeof(int)*m );
                     memcpy( east_cov_stack[k], east_cov + e, sizeof(int)*m );
                        
                     place_block( s, e, h, k );
                     if ( recursia( k + 1 ) ) return 1;
                     __flag = 1;

                     memcpy( south_cov + s, south_cov_stack[k], sizeof(int)*m );
                     memcpy( east_cov + e, east_cov_stack[k], sizeof(int)*m );
                  }
               }
               else
               {
                  if ( try_place_y( s, e, h ) )
                  {
                     memcpy( south_cov_stack[k], south_cov + s, sizeof(int)*m );
                     memcpy( east_cov_stack[k], east_cov + e, sizeof(int)*m );
                        
                     move_block_y(k);
                     if ( recursia( k + 1 ) ) return 1;
                     __flag = 1;

                     memcpy( south_cov + s, south_cov_stack[k], sizeof(int)*m );
                     memcpy( east_cov + e, east_cov_stack[k], sizeof(int)*m );                  
                  }
                  else
                  {
                     flag = 0;
                     if ( __flag ) { remove_last_block(k); __flag = 0; }
                  }
               }
            }

            if ( __flag ) { remove_last_block(k); __flag = 0; }
         }
      }
   }

   return 0;
}

int try_blocks( void )
{
   int i;
   
   if ( heights_cnt == 0 ) return 0;

////
   int k, h;

   for ( k = 0; k < heights_cnt; k++ )
   {
      h = heights[k]->h;

      if ( (heights[k]->p.s_cnt == m) && (heights[k]->p.e_cnt == m) )
      {
         place_block( heights[k]->p.sx, heights[k]->p.ex, h, k );
         height_covered[k] = 1;
      }
   }

////

   if ( greedy(0) ) return 1;

   memset( south_cov, 0, sizeof(int)*n );
   memset( east_cov, 0, sizeof(int)*n );
   for ( i = 0; i < n; i++ ) memset( map[i], 0, sizeof(int)*n );

////
   for ( k = 0; k < heights_cnt; k++ )
   {
      h = heights[k]->h;

      if ( (heights[k]->p.s_cnt == m) && (heights[k]->p.e_cnt == m) )
      {
         place_block( heights[k]->p.sx, heights[k]->p.ex, h, k );
         height_covered[k] = 1;
      }
   }
////
   

   return recursia(0);
}

int main( void )
{
   int i, solution;
   FILE * f;

   f = fopen( "block.in", "r" );
   fscanf( f, "%d %d", &n, &m );

   for ( i = 0; i < n; i++ ) { fscanf( f, "%d", south + i ); }
   for ( i = 0; i < n; i++ ) { fscanf( f, "%d", east + i ); }
   
   fclose(f);

   if ( solution = init_heights() ) solution = try_blocks();

   for ( i = 0; i < heights_cnt; i++ ) free( heights[i] );

   f = fopen( "block.out", "w" );

   if ( !solution )
   {
      fprintf( f, "NO" );
   }
   else
   {
      fprintf( f, "%d", heights_cnt );
      for ( i = heights_cnt - 1; i >= 0; i-- )
         fprintf( f, "\n%d %d %d", blocks[i].x, blocks[i].y, blocks[i].h );
   }

   fclose(f);
   
   return 0;
}
