// Reshenie na zadacha 2 za PC Magazine ot Peter Kormushev
// -------------------------------------------------------
#include <stdio.h>
#include <alloc.h>
#include <process.h>
#include <mem.h>

typedef unsigned char byte;

typedef struct {
	byte xexists,yexists;
	byte *x,*y;
	byte xcnt,ycnt;
	byte xsol,ysol;
	} sblock;

byte complex[100][100]={0};
byte sprofile[101]={0},eprofile[101]={0};
byte n,m,k;
sblock block[101]={0};
FILE *fin,*fout;

int sparse()
{
int ii,jj,kk,hh;
int start,end;
byte xpos[101];

   start=0;
   for (ii=0;ii<n;ii++)
	if (sprofile[ii+1] != sprofile[start])
	{
	   end=ii;
	   if (sprofile[start]==0) { start=end+1; continue;};

	   hh=sprofile[start];
	   if ((end-start+1) > m) return 1;   // longer than possible
	   if (block[hh].xexists==1) return 1;  // 2 times the same block
	   block[hh].xexists=1;

	   if ((ii==0) || (sprofile[start-1] < hh)) //beginning
	   {
	      block[hh].xcnt=1;
	      xpos[0]=start;
	   };
	   if (sprofile[end+1] < hh)   // ending
	   {
	      if ((block[hh].xcnt) && (end-start+1 < m)) return 1; //shorter than possible
	      block[hh].xcnt=1;
	      xpos[0]=end-m+1;
	   };
	   if (!block[hh].xcnt) // not computed yet
	   {
	     block[hh].xcnt= m-(end-start+1)+1;
	     for (jj=0;jj<block[hh].xcnt;jj++)
		xpos[jj]=start-block[hh].xcnt+1+jj;
	   };
	   block[hh].x= (byte *) malloc(block[hh].xcnt);
	   memcpy(block[hh].x, xpos,block[hh].xcnt);
	   start=end+1;
	};

   return 0;
};
int eparse()
{
int ii,jj,kk,hh;
int start,end;
byte ypos[101];

   start=0;
   for (ii=0;ii<n;ii++)
	if (eprofile[ii+1] != eprofile[start])
	{
	   end=ii;
	   if (eprofile[start]==0) { start=end+1; continue;};

	   hh=eprofile[start];
	   if ((end-start+1) > m) return 1;   // longer than possible
	   if (block[hh].yexists==1) return 1;  // 2 times the same block
	   block[hh].yexists=1;

	   if ((ii==0) || (eprofile[start-1] < hh)) //beginning
	   {
	      block[hh].ycnt=1;
	      ypos[0]=start;
	   };
	   if (eprofile[end+1] < hh)   // ending
	   {
	      if ((block[hh].ycnt) && (end-start+1 < m)) return 1; //shorter than possible
	      block[hh].ycnt=1;
	      ypos[0]=end-m+1;
	   };
	   if (!block[hh].ycnt) // not computed yet
	   {
	     block[hh].ycnt= m-(end-start+1)+1;
	     for (jj=0;jj<block[hh].ycnt;jj++)
		ypos[jj]=start-block[hh].ycnt+1+jj;
	   };
	   block[hh].y= (byte *) malloc(block[hh].ycnt);
	   memcpy(block[hh].y, ypos,block[hh].ycnt);
	   start=end+1;
	};

   return 0;


};

void computek()
{
int ii;

   k=0;
   for (ii=1;ii<=100;ii++)
      if (block[ii].xexists) k++;
}

int xparse()
{
int ii,jj,kk;
byte xpos[101]={0};
byte xcnt=0;

   for (ii=100;ii>0;ii--)
      if ( (!block[ii].xexists) && (block[ii].yexists) ) // only y exists
      {
	 for (jj=ii+1;jj<=100;jj++)
	 if (block[jj].xexists)
	 {
	    for (kk=0;kk<block[jj].xcnt;kk++)   // should avoid repeating x-s
	       if (!xpos[block[jj].x[kk]])
	       {
		  xpos[block[jj].x[kk]]=1;
		  xcnt++;
	       };
	 };
	 if (xcnt==0) return 1; // no bigger block to hide it
	 block[ii].xcnt=xcnt;
	 block[ii].x= (byte *) malloc(block[ii].xcnt);
	 xcnt=0;
	 for (kk=0;kk<101;kk++)
	    if (xpos[kk]) block[ii].x[xcnt++]=kk;
	 block[ii].xexists=1;
      };
   return 0;
};

int yparse()
{
int ii,jj,kk;
byte ypos[101]={0};
byte ycnt=0;

   for (ii=100;ii>0;ii--)
      if ( (!block[ii].yexists) && (block[ii].xexists) ) // only y exists
      {
	 for (jj=ii+1;jj<=100;jj++)
	 if (block[jj].yexists)
	 {
	    for (kk=0;kk<block[jj].ycnt;kk++)   // should avoid repeating x-s
	       if (!ypos[block[jj].y[kk]])
	       {
		  ypos[block[jj].y[kk]]=1;
		  ycnt++;
	       };
	 };
	 if (ycnt==0) return 1; // no bigger block to hide it
	 block[ii].ycnt=ycnt;
	 block[ii].y= (byte *) malloc(block[ii].ycnt);
	 ycnt=0;
	 for (kk=0;kk<101;kk++)
	    if (ypos[kk]) block[ii].y[ycnt++]=kk;
	 block[ii].yexists=1;
      };
   return 0;

};

void printsolution()
{
byte ii;

   computek();
   fprintf(fout,"%i\n",k);
   for (ii=1;ii<=100;ii++)
      if (block[ii].xexists)
	 fprintf(fout,"%i %i %i\n",block[ii].xsol,block[ii].ysol,ii);
};

int isfree(byte x, byte y)
{
byte i;

   for (i=x;i<x+m;i++)
	if (complex[i][y]) return 0;
   for (i=x;i<x+m;i++)
	if (complex[i][y+m-1]) return 0;
   for (i=y;i<y+m;i++)
	if (complex[x][i]) return 0;
   for (i=y;i<y+m;i++)
	if (complex[x+m-1][i]) return 0;

   return 1;
};

void setfree(byte x,byte y)
{
byte i;

   for (i=x;i<x+m;i++)
	complex[i][y]=0;
   for (i=x;i<x+m;i++)
	complex[i][y+m-1]=0;
   for (i=y;i<y+m;i++)
	complex[x][i]=0;
   for (i=y;i<y+m;i++)
	complex[x+m-1][i]=0;

};
void notfree(byte x,byte y)
{
byte i;

   for (i=x;i<x+m;i++)
	complex[i][y]=1;
   for (i=x;i<x+m;i++)
	complex[i][y+m-1]=1;
   for (i=y;i<y+m;i++)
	complex[x][i]=1;
   for (i=y;i<y+m;i++)
	complex[x+m-1][i]=1;

};

void tryit(byte h)
{
byte ii,jj;

if (h==0)
{
    printsolution();
    fclose(fout);
    fclose(fin);
    exit(0);
};

if (!(block[h].xexists)) { tryit(h-1); return; }

   for (ii=0;ii<block[h].xcnt;ii++)
      for (jj=0;jj<block[h].ycnt;jj++)
      {
	 if (isfree(block[h].x[ii],block[h].y[jj]))
	 {
	    notfree(block[h].x[ii],block[h].y[jj]);
	    block[h].xsol=block[h].x[ii];
	    block[h].ysol=block[h].y[jj];
	    tryit(h-1);
	    setfree(block[h].x[ii],block[h].y[jj]);
	 };
      };
}

void main()
{
int i;

    fin=fopen("BLOCK.IN","r");
    fout=fopen("BLOCK.OUT","w");

    fscanf(fin,"%i%i",&n,&m);
    for (i=0;i<n;i++)
	fscanf(fin,"%i",&sprofile[i]);
    for (i=0;i<n;i++)
	fscanf(fin,"%i",&eprofile[i]);

    sprofile[100]=eprofile[100]=0;

    if (sparse() || eparse() || xparse() || yparse())
    {
       fprintf(fout,"NO\n");
    }
    else
    {
       tryit(100);
       fprintf(fout,"NO\n");

    };

    fclose(fout);
    fclose(fin);

}
