/*

VIII PC Magazine Bulgaria & Musala Soft programming contest
Problem 2: BLOCK

Author: Peter Ivanov Petrov, 21, Sofia
        software developer / university student
        e-mail: piettropro@bigfoot.com
        www: http://pesho.cjb.net, http://www.pesho.com
        phone: (359-2)9340014


VIII     PC Magazine Bulgaria  Musala Soft
 2:  

:   , 21 ., . 
        / 
       e-mail: piettropro@bigfoot.com
       www: http://pesho.cjb.net, http://www.pesho.com
       . (359-2)9340014



  
---------------------

   :
  -  
  -  branch'n'bound (  -  )
  - 
  -  (  , ? ;-)

P.S.    .  :
  -   (       ,    )
  -    (      , 
        ) -  K=0,   "NO"
  - branch'n'bound-  ---  (    
     ;  ,     
     ,      ... 
      )
  -  ,      
     ,   branch'n'bound-   
          ,   
     ...     ,   

P.P.S. ,  .  :
  - ;      ,   
    

P.P.S.    !

P.P.P.S. ,       ;-)


22 , 2000 .


*/

#include <stdio.h>
#include <algorithm>
#include <set>
using namespace std;


/////////////
// Globals:

const char *IN_FILENAME="block.in";
const char *OUT_FILENAME="block.out";
enum { 
	MAX_N = 128, // 100
	MAX_M =  16, //  10
	MAX_K = 128, // 100
	MAX_H = 128  // 100 
};

typedef int blockmap[MAX_N][MAX_N];

struct block {
	int h,x,y,min_x,max_x,min_y,max_y,area;
	blockmap *bmap;
};

struct lessBlockArea : public std::binary_function<block,block,bool> {
	bool operator()(const block& a,const block& b) const {
		return (a.area<b.area) || ((a.area==b.area) && (a.h>b.h));
	}
};

struct lessBlockH : public std::binary_function<block,block,bool> {
	bool operator()(const block& a,const block& b) const { return a.h<b.h; }
};


int N,M,K;
int h_x[MAX_N],h_y[MAX_N],maxb_x[MAX_N],maxb_y[MAX_N];
blockmap bmaparray[MAX_K];
block bl[MAX_K];
bool solved;


inline int maxb(int x,int y) { 
	return (maxb_x[x]<maxb_y[y])?(maxb_x[x]):(maxb_y[y]); 
}


/////////////////
// Heuristic 1:

bool heur1(int *h) {
	if (M<=1) return true;
	int i,l=0,c=1;
	bool gt=false;
	for(i=0;i<=N;++i) {
		int v=(i<N)?(h[i]):(0);
		if (v==l) ++c; else { 
			if (gt && v<l && c<M) return false;
			c=1; gt=(v>l); l=v; 
		}
	}
	return true;
}


/////////////////
// Heuristic 2:

bool heur2(int *h) {
	int i,firstpos[MAX_H+1];
	for(i=0;i<=MAX_H;++i) firstpos[i]=-1;
	for(i=0;i<N;++i) if (h[i]>0) 
		if (firstpos[h[i]]==-1) firstpos[h[i]]=i; 
		else if (i-firstpos[h[i]]+1>M) return false;
	return true;
}


////////////////////
// Branch'n'bound:

inline void mark(int k,int x,int y) {
	if ((++((*(bl[k].bmap))[x][y]))==1) --(bl[k].area);
}

inline void unmark(int k,int x,int y) {
	if ((--((*(bl[k].bmap))[x][y]))<=0) ++(bl[k].area);
}

void recurse(int depth) {
	if (depth>=K) {
		int t_x[MAX_N],t_y[MAX_N];
		int i,j;
		for(i=0;i<N;++i) t_x[i]=t_y[i]=0;
		for(i=0;i<K;++i) {
			block *blp=bl+i;
			for(j=0;j<M;++j) {
				if (blp->h>t_x[blp->x+j]) if ((t_x[blp->x+j]=blp->h)>h_x[blp->x+j]) return;
				if (blp->h>t_y[blp->y+j]) if ((t_y[blp->y+j]=blp->h)>h_y[blp->y+j]) return;
			}
		}
		for(i=0;i<N;++i) if ((t_x[i]!=h_x[i]) || (t_y[i]!=h_y[i])) return;
		solved=true; return;
	}
	int x,y,count=0; block *blp=bl+depth; if (blp->area<=0) return;
	for(x=blp->min_x;x<=blp->max_x;++x) for(y=blp->min_y;y<=blp->max_y;++y) 
		if ((maxb(x,y)>=blp->h) && ((*(blp->bmap))[x][y]==0)) {
			blp->x=x; blp->y=y;
			int i,lasti=-1,ax,ay,minx,miny,maxx,maxy; 
			bool flag=false;
			for(i=depth+1;i<K;++i) {
				lasti=i;
				minx=x-M+1; if (minx<bl[i].min_x) minx=bl[i].min_x;
				miny=y-M+1; if (miny<bl[i].min_y) miny=bl[i].min_y;
				maxx=x+M-1; if (maxx>bl[i].max_x) maxx=bl[i].max_x;
				maxy=y+M-1; if (maxy>bl[i].max_y) maxy=bl[i].max_y;
				for(ax=minx;ax<=maxx;++ax) for(ay=miny;ay<=maxy;++ay) mark(i,ax,ay);
				if (flag=(bl[i].area<=0)) break;				
			}
			if (!flag) recurse(depth+1); if (solved) return;
			for(i=depth+1;i<=lasti;++i) {
				minx=x-M+1; if (minx<bl[i].min_x) minx=bl[i].min_x;
				miny=y-M+1; if (miny<bl[i].min_y) miny=bl[i].min_y;
				maxx=x+M-1; if (maxx>bl[i].max_x) maxx=bl[i].max_x;
				maxy=y+M-1; if (maxy>bl[i].max_y) maxy=bl[i].max_y;
				for(ax=minx;ax<=maxx;++ax) for(ay=miny;ay<=maxy;++ay) unmark(i,ax,ay);
			}
			if ((++count)>=(blp->area)) return;
		}
}


///////////////////
// Main function:

void __cdecl main() {
	FILE *fp;
	if (!(fp=fopen(IN_FILENAME,"rt"))) abort();
	fscanf(fp," %i %i",&N,&M);
	int i;
	for(i=0;i<N;++i) fscanf(fp," %i",h_x+i);
	for(i=0;i<N;++i) fscanf(fp," %i",h_y+i);
	fclose(fp);
	//
	solved=false;
	if (heur1(h_x) && heur1(h_y) && heur2(h_x) && heur2(h_y)) {
		for(i=0;i<=N-M;++i) {
			int j; maxb_x[i]=h_x[i]; maxb_y[i]=h_y[i];
			for(j=1;j<M;++j) {
				if (h_x[i+j]<maxb_x[i]) maxb_x[i]=h_x[i+j];
				if (h_y[i+j]<maxb_y[i]) maxb_y[i]=h_y[i+j];
			}
		}
		set<int> all_h;
		for(i=0;i<N;++i) { if (h_x[i]) all_h.insert(h_x[i]); if (h_y[i]) all_h.insert(h_y[i]); }
		K=all_h.size(); set<int>::const_iterator ai=all_h.begin();
		for(i=K-1;i>=0;--i) {
			int h=*(ai++),min=0,max=N-M,j; bl[i].h=h;
			for(j=0;j<N;++j) if (h_x[j]==h) min=j+1-M;
			for(j=N-1;j>=0;--j) if (h_x[j]==h) max=j;
			while(min<=max && maxb_x[min]<h) ++min;
			while(max>=min && maxb_x[max]<h) --max;
			bl[i].min_x=(min<0)?0:min; bl[i].max_x=(max>N-M)?(N-M):max;
			min=0; max=N-M;
			for(j=0;j<N;++j) if (h_y[j]==h) min=j+1-M;
			for(j=N-1;j>=0;--j) if (h_y[j]==h) max=j;
			while(min<=max && maxb_y[min]<h) ++min;
			while(max>=min && maxb_y[max]<h) --max;
			bl[i].min_y=(min<0)?0:min; bl[i].max_y=(max>N-M)?(N-M):max;
			if (bl[i].max_x<bl[i].min_x || bl[i].max_y<bl[i].min_y) bl[i].area=0;
			else bl[i].area=(bl[i].max_x+1-bl[i].min_x)*(bl[i].max_y+1-bl[i].min_y);
			int x,y;
			bl[i].bmap=bmaparray+i;
			for(x=bl[i].min_x;x<=bl[i].max_x;++x)
				for(y=bl[i].min_y;y<=bl[i].max_y;++y) {
					(*(bl[i].bmap))[x][y]=0;
					if (maxb(x,y)<bl[i].h) { --(bl[i].area); ++((*(bl[i].bmap))[x][y]); }
				}
		}
		sort(bl,bl+K,lessBlockArea());
		recurse(0);
	}
	//
	if (!(fp=fopen(OUT_FILENAME,"wt"))) abort();
	if (solved && (K>0)) {
		sort(bl,bl+K,lessBlockH());
		fprintf(fp,"%d\n",K);
		for(i=0;i<K;++i) fprintf(fp,"%d %d %d\n",bl[i].x,bl[i].y,bl[i].h);
	} else fprintf(fp,"NO\n");
	fclose(fp);
}
