{by Peter Sabev, 2000}
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65384,0,655360}

const fin='BLOCK.IN';
      fon='BLOCK.OUT';
      max=101;

type Block=record
             x,y,h:byte;
           end;

var fi,fo:Text;
    a:array [1..max,1..max] of byte;          { Minimal height }
    aa:array [1..max,1..max] of boolean;      { Boolean map }
    b:array [1..max] of Block;                { The solution }
    cn:array [1..max] of byte;                { The number of rows/columns
                                                for each block height }
    p:array [1..max*max] of Block;            { All possible blocks list }
    ppos:integer;
    x,y:array [1..max] of byte;               { West and south views }
    n,m:byte;                                 { N M }
    h:array [1..max] of byte;                 { All heights in the test }
    hp:array [1..max] of boolean;             { Is that height put }
    hpos:byte;
    found,                                    { Is there a solution found }
    error:boolean;                            { Is there any error:
                                                If =TRUE, no solution }

procedure Read_Data;
var i:byte;
begin
assign(fi,fin);
reset(fi);
readln(fi,n,m);
if m>n then error:=true;
for i:=1 to n do
read(fi,x[i]);
readln(fi);
for i:=1 to n do
read(fi,y[i]);
readln(fi);
close(fi);
end;

procedure Extract_Heights;
var i,j,tmp:byte;
    zero:integer;
begin
fillchar(a,sizeof(a),0);
fillchar(h,sizeof(h),0);
fillchar(cn,sizeof(cn),0);
hpos:=0;
zero:=0;
for i:=1 to n do
begin
for j:=1 to n do
begin
if x[i]<y[j] then a[i,j]:=x[i] else a[i,j]:=y[j];
if a[i,j]=0 then inc(zero);
end;
if x[i]>0 then
  begin
    if cn[x[i]]=0 then begin inc(hpos); h[hpos]:=x[i]; end;
    inc(cn[x[i]]);
  end;
if y[i]>0 then
  begin
    if cn[y[i]]=0 then begin inc(hpos); h[hpos]:=y[i]; end;
    inc(cn[y[i]]);
  end;
end;
if hpos=0 then found:=true;
if not found then
for i:=1 to hpos-1 do
for j:=i+1 to hpos do
if h[i]<h[j] then begin tmp:=h[i]; h[i]:=h[j]; h[j]:=tmp; end;
if hpos*m*m+zero>n*n then error:=true;
end;

function canbeput(xx,yy,h:byte):boolean;
var i,j,c:byte;
    bool:boolean;
begin
c:=0;
for i:=xx to xx+m-1 do
if x[i]=h then inc(c);
for i:=yy to yy+m-1 do
if y[i]=h then inc(c);
bool:=c=cn[h];
if bool then
for i:=xx to xx+m-1 do
if bool then
for j:=yy to yy+m-1 do
if (a[i,j]<h) or (aa[i,j]) then bool:=false;
canbeput:=bool;
end;

function avail(x,y:byte):boolean;
var i,j:byte;
    bool:boolean;
begin
bool:=true;
for i:=x to x+m-1 do
for j:=y to y+m-1 do
if aa[i,j] then bool:=false;
avail:=bool;
end;

procedure PutP(x,y,h:byte);
begin
inc(ppos);
p[ppos].x:=x;
p[ppos].y:=y;
p[ppos].h:=h;
end;

procedure Put(z:Block);
var i,j:byte;
begin
hp[z.h]:=true;
b[z.h]:=z;
for i:=z.x to z.x+m-1 do
for j:=z.y to z.y+m-1 do
aa[i,j]:=true;
end;

procedure DePut(z:Block);
var i,j:byte;
begin
hp[z.h]:=false;
b[z.h].h:=0;
b[z.h].x:=0;
b[z.h].y:=0;
for i:=z.x to z.x+m-1 do
for j:=z.y to z.y+m-1 do
aa[i,j]:=false;
end;

procedure check;
var xx,yy:array [1..max] of byte;
    i:integer;
    j:byte;
    bool:boolean;
begin
fillchar(xx,sizeof(xx),0);
fillchar(yy,sizeof(yy),0);
for i:=1 to hpos do
begin
  for j:=b[h[i]].x to b[h[i]].x+m-1 do
    if xx[j]<b[h[i]].h then xx[j]:=b[h[i]].h;
  for j:=b[h[i]].y to b[h[i]].y+m-1 do
    if yy[j]<b[h[i]].h then yy[j]:=b[h[i]].h;
end;
bool:=true;
for i:=1 to n do
if (x[i]<>xx[i]) or (y[i]<>yy[i]) then bool:=false;
if bool then found:=true;
end;

procedure Init_Choose;
var cc,i,j,k:integer;
    z:Block;
    change:boolean;
begin
for i:=1 to h[1] do
if cn[i]>2*m then error:=true;
ppos:=0;
fillchar(aa,sizeof(a),false);
if not error then
for k:=1 to hpos do
if not error then
begin
cc:=0;
for i:=1 to n-m+1 do
for j:=1 to n-m+1 do
if canbeput(i,j,h[k]) then begin
if cc=0 then
begin
z.x:=i;
z.y:=j;
z.h:=h[k];
inc(cc);
end else
if cc=1 then
begin
putp(z.x,z.y,z.h);
putp(i,j,h[k]);
inc(cc);
end else putp(i,j,h[k]);
end;
if cc=0 then error:=true else
if cc=1 then Put(z);
end;
repeat
change:=false;
k:=1;
if not error then
repeat
if (ppos>0) and not avail(p[k].x,p[k].y) then begin
for i:=k to ppos do p[i]:=p[i+1];
change:=true;
dec(ppos);
dec(k);
end;
inc(k);
until k>ppos;
if change and not error then
for j:=1 to hpos do
if not hp[h[j]] then
begin
  k:=0;
  for i:=1 to ppos do
    begin
      if p[i].h=h[j] then begin inc(k); cc:=i; end;
    end;
  if k=1 then begin
    b[p[cc].h]:=p[cc];
    if not avail(p[cc].x,p[cc].y) then error:=true else
    begin
    put(p[cc]);
    for i:=1 to ppos do
    p[i]:=p[i+1];
    dec(ppos);
    change:=true;
    end;
  end;
end;
until not change;
end;

procedure Show_Result;
var i:byte;
begin
assign(fo,fon);
rewrite(fo);
if error or (not found) then writeln(fo,'NO') else
begin
writeln(fo,hpos);
for i:=hpos downto 1 do
writeln(fo,b[h[i]].x-1,' ',b[h[i]].y-1,' ',b[h[i]].h);
end;
close(fo);
end;

procedure Calculate_It;
var hmin,hmax:array [1..max] of integer;
    j,ssize:byte;
    i:integer;


procedure Try(pos:byte);
var i:integer;
begin
if not found then
for i:=hmin[pos] to hmax[pos] do
if not found then
if avail(p[i].x,p[i].y) then
begin
put(p[i]);
if pos<ssize then Try(pos+1) else check;
if not found then deput(p[i]);
end;
end;

procedure Brood_Force;
begin
try(1);
end;

begin
if (ppos>0) and not error then
begin
fillchar(hmin,sizeof(hmin),0);
fillchar(hmax,sizeof(hmax),0);
j:=1;
hmin[j]:=1;
for i:=2 to ppos do
  if p[i].h<>p[i-1].h then begin
  hmax[j]:=i-1;
  inc(j);
  hmin[j]:=i;
  end;
hmax[j]:=ppos;
ssize:=j;
Brood_Force;
end else if not error then check;
end;

begin
found:=false;
error:=false;
Read_Data;
Extract_Heights;
Init_Choose;
Calculate_It;
Show_Result;
end.