/*
  Task: BLOCKS
  Name: Petko Minkov
  Compiler: BC++ 3.1
*/
#include <process.h>
#include <fstream.h>

#define max(a,b) (a > b ? a : b)

#define MAXN 101

struct block {
  int info;
  int h;
};

struct answer {
  int x,y,h;
};

typedef char matrix[MAXN][MAXN];
typedef int vector[MAXN];

int    s[2][MAXN];
int    n,m,maxh,blocks;
block  b[MAXN];
vector xcover,ycover,hinfo;
matrix used,ygood,xgood;
answer ans[MAXN];

void readdata()
{
   int i,j;
   ifstream fin("block.in");

   fin >> n >> m;
   for(i=0;i<2;i++)
     for(j=1;j<=n;j++)
     {
	fin >> s[i][j];
	maxh = max(maxh, s[i][j]);
	hinfo[s[i][j]]++;
	if(i == 0) xcover[s[i][j]]++;
	      else ycover[s[i][j]]++;
     }

   fin.close();
}

void prepare()
{
   int   i, j;
   block tmp;

   for(i=1;i<=maxh;i++)
     if(hinfo[i])
     {
	blocks++;
	b[blocks].h = i;
	b[blocks].info = hinfo[i];
     }

   for(i=1;i<blocks;i++)
     for(j=i+1;j<=blocks;j++)
       if(b[i].info < b[j].info)
       {
	  tmp = b[i];
	  b[i] = b[j];
	  b[j] = tmp;
       }
}

void findpositions()
{
   int i,y,x,cover,j;

   for(i=1;i<=blocks;i++)
   {
      for(y=1;y<=n-m+1;y++)
      {
	 cover = 0;
	 for(j=y;j<y+m;j++)
	   if(s[1][j] < b[i].h) goto NEXTY;
	   else if(s[1][j] == b[i].h) cover++;

	 if(cover == ycover[b[i].h])
	 {
	    ygood[i][0]++;
	    ygood[i][ygood[i][0]] = y;
	 }

	 NEXTY:
      }

      for(x=1;x<=n-m+1;x++)
      {
	 cover = 0;
	 for(j=x;j<x+m;j++)
	   if(s[0][j] < b[i].h) goto NEXTX;
	   else if(s[0][j] == b[i].h) cover++;

	 if(cover == xcover[b[i].h])
	 {
	    xgood[i][0]++;
            xgood[i][xgood[i][0]] = x;
	 }

	 NEXTX:
      }
   }
}

int put(int y, int x, int ind)
{
   int i, j;

   for(i=y;i<y+m;i++)
     for(j=x;j<x+m;j++)
       used[i][j] = ind;
}

int canput(int y, int x, int ind)
{
   int i, j, cover;

   if(used[y][x]) return 0;
   if(used[y][x+m-1]) return 0;
   if(used[y+m-1][x]) return 0;
   if(used[y+m-1][x+m-1]) return 0;

   return 1;
}

void printsol()
{
   int    i,j;
   answer tmp;

   for(i=1;i<=blocks;i++)
     for(j=i+1;j<=blocks;j++)
       if(ans[i].h > ans[j].h)
       {
	  tmp = ans[i];
	  ans[i] = ans[j];
	  ans[j] = tmp;
       }

   ofstream fout("block.out");
   fout << blocks << endl;
   for(i=1;i<=blocks;i++)
     fout << ans[i].x-1 << " " <<ans[i].y-1 << " " << ans[i].h << endl;
   fout.close();
   exit(0);
}

void rec(int ind)
{
   int i,j,y,x;

   if(ind == blocks+1) printsol();
   else
   for(i=1;i<=ygood[ind][0];i++)
     for(j=1;j<=xgood[ind][0];j++)
     {
	y = ygood[ind][i];
	x = xgood[ind][j];

	if(canput(y, x, ind))
	{
	   put(y, x, b[ind].h);
	   ans[ind].y = y;
	   ans[ind].x = x;
	   ans[ind].h = b[ind].h;
	   rec(ind+1);
	   put(y, x, 0);
	}
     }
}

void solveit()
{
   rec(1);
}

void main()
{
   readdata();
   prepare();
   findpositions();
   solveit();

   ofstream fout("block.out");
   fout << "NO\n";
   fout.close();
}
