// Block.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#include <fstream.h>
#include <process.h>

int m,n;

int South[100],East[100];

int NumBlocks1,BlockHeight1[100],NumBlocks2,BlockHeight2[100];
int NumBlocks,BlockHeight[100];

struct BlockArr {
	int x,y;
	int firstx,lastx,firsty,lasty;
	bool fixed,fixedx,fixedy,placed;
} Blocks[100];

bool Taken[100][100];

int HowHighCanPlace[100][100];

// Handles the NO SOLUTION case
void NoSolution()
{
	ofstream f;

	f.open("BLOCK.OUT");

	f<<"NO"<<endl;

	f.close();

	exit(0);
}

// Sorts and merges the two BlockHeight arrays
void SortHeights()
{
	int i,j,k,m,mi,t;

	/* We sort the first array and check for inconsistences */
	for(i=0;i<NumBlocks1;i++) {
		m=BlockHeight1[i];
		mi=i;

		for(j=i;j<NumBlocks1;j++) {
			if(BlockHeight1[j]>=m) {
				m=BlockHeight1[j];
				mi=j;
			}
		}

		/* Swap */
		t=BlockHeight1[i];
		BlockHeight1[i]=BlockHeight1[mi];
		BlockHeight1[mi]=t;

		if((i>0)&&(BlockHeight1[i]==BlockHeight1[i-1])) NoSolution();
	}

	/* We now sort the second array, checking for inconsistences */
	for(i=0;i<NumBlocks2;i++) {
		m=BlockHeight2[i];
		mi=i;

		for(j=i;j<NumBlocks2;j++) {
			if(BlockHeight2[j]>=m) {
				m=BlockHeight2[j];
				mi=j;
			}
		}

		/* Swap */
		t=BlockHeight2[i];
		BlockHeight2[i]=BlockHeight2[mi];
		BlockHeight2[mi]=t;

		if((i>0)&&(BlockHeight2[i]==BlockHeight2[i-1])) NoSolution();
	}

	/* And finally, we merge the two arrays */
	for(i=j=k=0;(j<NumBlocks1)&&(k<NumBlocks2);i++) {
		if(BlockHeight1[j]==BlockHeight2[k]) {
			BlockHeight[i]=BlockHeight1[j++];
			k++;
		}
		else if(BlockHeight1[j]>BlockHeight2[k]) BlockHeight[i]=BlockHeight1[j++];
		else BlockHeight[i]=BlockHeight2[k++];
	}

	while(j<NumBlocks1) BlockHeight[i++]=BlockHeight1[j++];
	while(k<NumBlocks2) BlockHeight[i++]=BlockHeight2[k++];

	NumBlocks=i;
}

// Reads the input data
void ReadData()
{
	ifstream f;
	int i,c,cprev=-1,cnum;

	f.open("BLOCK.IN");

	f>>n>>m;

	/* We read the first line of the file, checking for long sequences */
	for(i=0;i<n;i++) {
		f>>c;

		South[i]=c;

		if(!c) cprev=0;
		else {
			if(c!=cprev) {
				cprev=c;
				cnum=1;
				BlockHeight1[NumBlocks1++]=c;
			}
			else cnum++;

			if(cnum>m) NoSolution();
		}
	}

	cprev=-1;

	for(i=0;i<n;i++) {
		f>>c;

		East[i]=c;

		if(!c) cprev=0;
		else {
			if(c!=cprev) {
				cprev=c;
				cnum=1;
				BlockHeight2[NumBlocks2++]=c;
			}
			else cnum++;

			if(cnum>m) NoSolution();
		}
	}

	f.close();

	SortHeights();
}

inline void Take(int x,int y)
{
	register int i,j;

	for(i=x-m+1;i<x+m;i++) if((x>=0)&&(x<n)) {
		for(j=y-m+1;j<y+m;j++) if((y>=0)&&(y<n)) Taken[i][j]=true;
	}
}

inline void UnTake(int x,int y)
{
	register int i,j;

	for(i=x-m+1;i<x+m;i++) if((x>=0)&&(x<n)) {
		for(j=y-m+1;j<y+m;j++) if((y>=0)&&(y<n)) Taken[i][j]=false;
	}
}

void GetBlockLocations()
{
	int CurrentBlock,BlockHeight,firstx,lastx,firsty,lasty,i;
	bool fixedx,fixedy;

	for(CurrentBlock=0;CurrentBlock<NumBlocks;CurrentBlock++) {
		BlockHeight=::BlockHeight[CurrentBlock];

		/* We find the first and last X points */
		for(i=0;(i<n)&&(South[i]!=BlockHeight);i++);

		if(i<n) {
			firstx=i;

			for(i++;(i<n)&&(South[i]==BlockHeight);i++);
			lastx=i-1;
		}
		else firstx=lastx=-1;

		/* Then we find the first and last Y points */
		for(i=0;(i<n)&&(East[i]!=BlockHeight);i++);

		if(i<n) {
			firsty=i;

			for(i++;(i<n)&&(East[i]==BlockHeight);i++);
			lasty=i-1;
		}
		else firsty=lasty=-1;

		/* Check if X is fixed */
		if(firstx==-1) {
			fixedx=false;

			Blocks[CurrentBlock].firstx=0;
			Blocks[CurrentBlock].lastx=n-m;
		}
		else {
			if((firstx==0)||(South[firstx-1]<South[firstx])||(lastx-firstx+1==m)) {
				fixedx=true;

				Blocks[CurrentBlock].x=firstx;
			}
			else if((lastx==n-1)||(South[lastx+1]<South[lastx])) {
				fixedx=true;

				Blocks[CurrentBlock].x=lastx-m+1;
			}
			else {
				fixedx=false;

				Blocks[CurrentBlock].firstx=lastx-m+1;
				if(Blocks[CurrentBlock].firstx<0) Blocks[CurrentBlock].firstx=0;

				Blocks[CurrentBlock].lastx=firstx;
				if(Blocks[CurrentBlock].lastx>=n) Blocks[CurrentBlock].lastx=m-1;
			}
		}

		/* Check if Y is fixed */
		if(firsty==-1) {
			fixedy=false;

			Blocks[CurrentBlock].firsty=0;
			Blocks[CurrentBlock].lasty=n-m;
		}
		else {
			if((firsty==0)||(East[firsty-1]<East[firsty])||(lasty-firsty+1==m)) {
				fixedy=true;

				Blocks[CurrentBlock].y=firsty;
			}
			else if((lasty==n-1)||(East[lasty+1]<East[lasty])) {
				fixedy=true;

				Blocks[CurrentBlock].y=lasty-m+1;
			}
			else {
				fixedy=false;

				Blocks[CurrentBlock].firsty=lasty-m+1;
				if(Blocks[CurrentBlock].firsty<0) Blocks[CurrentBlock].firsty=0;

				Blocks[CurrentBlock].lasty=firsty;
				if(Blocks[CurrentBlock].lasty>=n) Blocks[CurrentBlock].lasty=m-1;
			}
		}

		Blocks[CurrentBlock].fixedx=fixedx;
		Blocks[CurrentBlock].fixedy=fixedy;

		/* Check if the block is fixed */
		if(fixedx&&fixedy) {
			Blocks[CurrentBlock].fixed=true;

			/* It is fixed, so try to place it */
			if(!Taken[Blocks[CurrentBlock].x][Blocks[CurrentBlock].y]) {
				Blocks[CurrentBlock].placed=true;

				Take(Blocks[CurrentBlock].x,Blocks[CurrentBlock].y);
			}
			else NoSolution(); // Can't place fixed block
		}
		else Blocks[CurrentBlock].fixed=false;
	}
}

bool Place(int CurrentBlock)
{
	int NextBlock,i,j,height,lastx,lasty;

	for(NextBlock=CurrentBlock+1;(NextBlock<NumBlocks)&&(Blocks[NextBlock].placed);NextBlock++);
	if(NextBlock==NumBlocks) NextBlock=-1;

	height=BlockHeight[CurrentBlock];

	if(Blocks[CurrentBlock].fixedx) {
		lastx=Blocks[CurrentBlock].x;
		lasty=Blocks[CurrentBlock].lasty;

		for(i=Blocks[CurrentBlock].firsty;i<=lasty;i++) {
			if((HowHighCanPlace[lastx][i]>=height)&&(!Taken[lastx][i])) {
				Blocks[CurrentBlock].y=i;
				Take(lastx,i);

				if(NextBlock==-1) return true;

				if(Place(NextBlock)) return true;

				UnTake(lastx,i);
			}
		}
	}
	else if(Blocks[CurrentBlock].fixedy) {
		lasty=Blocks[CurrentBlock].y;
		lastx=Blocks[CurrentBlock].lastx;

		for(i=Blocks[CurrentBlock].firstx;i<=lastx;i++) {
			if((HowHighCanPlace[i][lasty]>=height)&&(!Taken[i][lasty])) {
				Blocks[CurrentBlock].x=i;
				Take(i,lasty);

				if(NextBlock==-1) return true;

				if(Place(NextBlock)) return true;

				UnTake(i,lasty);
			}
		}
	}
	else {
		lastx=Blocks[CurrentBlock].lastx;
		lasty=Blocks[CurrentBlock].lasty;

		for(i=Blocks[CurrentBlock].firstx;i<=lastx;i++) {
			for(j=Blocks[CurrentBlock].firsty;j<=lasty;j++) {
				if((HowHighCanPlace[i][j]>=height)&&(!Taken[i][j])) {
					Blocks[CurrentBlock].x=i;
					Blocks[CurrentBlock].y=j;

					Take(i,j);

					if(NextBlock==-1) return true;

					if(Place(NextBlock)) return true;

					UnTake(i,lasty);
				}
			}
		}
	}

	return false;
}

void PrintSolution()
{
	ofstream f;
	int i;

	f.open("BLOCK.OUT");

	f<<NumBlocks<<'\n';

	for(i=NumBlocks-1;i>=0;i--) f<<Blocks[i].x<<' '<<Blocks[i].y<<' '<<BlockHeight[i]<<'\n';

	f.close();
}

inline int GetHowHigh(int x,int y)
{
	register int i,m1=1000,m2=1000;

	for(i=x;i<x+m;i++) if(South[i]<m1) m1=South[i];
	for(i=y;i<y+m;i++) if(East[i]<m2) m2=East[i];

	return (m1<m2?m1:m2);
}

void Solve()
{
	int CurrentBlock=0;
	register int i,j;

	/* Initialize block locations and place fixed blocks */
	GetBlockLocations();

	for(i=0;i<=n-m;i++) {
		for(j=0;j<=n-m;j++) {
			HowHighCanPlace[i][j]=GetHowHigh(i,j);
		}
	}

	/* Not all blocks are placed -> place them */
	while((CurrentBlock<NumBlocks)&&(Blocks[CurrentBlock].placed)) CurrentBlock++;

	if(CurrentBlock==NumBlocks) PrintSolution();
	else if(Place(CurrentBlock)) PrintSolution();
	else NoSolution();
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	ReadData();

	Solve();

 	return 0;
}



