////////////////////////////////////////////////////////////////////////
			// Definitions //
////////////////////////////////////////////////////////////////////////
#define	IN		"block.in"
#define OUT		"block.out"
#define MAX_BLOCKS	100
#define MAX_N		100
#define	MAX_M		10
////////////////////////////////////////////////////////////////////////
			// Include Files //
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <conio.h>
#include <process.h>
////////////////////////////////////////////////////////////////////////
			// Structures and Type Definitions //
////////////////////////////////////////////////////////////////////////
struct block
{
 unsigned short int h,x,y;
};
typedef unsigned short int USINT;
////////////////////////////////////////////////////////////////////////
			// Global Variables //
////////////////////////////////////////////////////////////////////////
block 			res[MAX_BLOCKS];
USINT		 	east[MAX_N],south[MAX_N],n,m;
USINT			num_blocks;
////////////////////////////////////////////////////////////////////////
			// Functions //
////////////////////////////////////////////////////////////////////////
void in()
{
FILE *fp;
int  i;
/////////
if((fp=fopen(IN,"r"))==NULL)
   {
    clrscr();
    printf("FILE ERROR");
    getch();
    exit(0);
   }
/////////
fscanf(fp,"%d%d",&n,&m);
for(i=0;i<n;i++)
   fscanf(fp,"%d",&(south[i]));
for(i=0;i<n;i++)
   fscanf(fp,"%d",&(east[i]));
/////////
fclose(fp);
}
////////////////////////////////////////////////////////////////////////
int prov(int height)
{
int i;
for(i=0;i<num_blocks;i++)
   if(res[i].h==height) return 1;
return 0;
}
////////////////////////////////////////////////////////////////////////
void opr_blocks()
{
int i;
//////
for(i=0;i<n;i++)
   if(south[i]>0&&prov(south[i])==0)
     {
      res[num_blocks].h=south[i];
      num_blocks++;
     }
for(i=0;i<n;i++)
   if(east[i]>0&&prov(east[i])==0)
     {
      res[num_blocks].h=east[i];
      num_blocks++;
     }
}
////////////////////////////////////////////////////////////////////////
int check_for_collisions(int el,int x,int y)
{
int i;
//////
for(i=0;i<el;i++)
   {
    if((res[i].x<=x&&res[i].x+m>x&&res[i].y<=y&&res[i].y+m>y)
      ||(res[i].x<=x+m&&res[i].x+m>x+m&&res[i].y<=y&&res[i].y+m>y)
      ||(res[i].x<=x&&res[i].x+m>x&&res[i].y<=y+m&&res[i].y+m>y+m)
      ||(res[i].x<=x+m&&res[i].x+m>x+m&&res[i].y<=y+m&&res[i].y+m>y+m)
      ) return 1;
   }
return 0;
}
////////////////////////////////////////////////////////////////////////
int check_shadows()
{
int i,j,nam;
////////////
for(i=0;i<n;i++)
   {
    nam=0;
    if(south[i]!=0)
      {
       for(j=0;j<num_blocks;j++)
	  if(south[i]==res[j].h&&i>=res[j].x&&i<=res[j].x+m)
	    nam=1;
      }
    else nam=1;
    if(nam==0) return 0;
   }
for(i=0;i<n;i++)
   {
    nam=0;
    if(east[i]!=0)
      {
       for(j=0;j<num_blocks;j++)
	  if(east[i]==res[j].h&&i>=res[j].y&&i<=res[j].y+m)
	    nam=1;
      }
    else nam=1;
    if(nam==0) return 0;
   }
return 1;
}
////////////////////////////////////////////////////////////////////////
int  find_pos(USINT tek)
{
int	ii,j;
USINT   xb=0,yb=0;
//////////////////
if(tek==num_blocks&&check_shadows()==1) return 1;
if(tek==num_blocks) return 0;
for(ii=n-1;ii>=0;ii--)
   {
    if(south[ii]>=res[tek].h)
      {
       xb++;
       if(xb==m)
	 {
	  for(j=n-1;j>=0;j--)
	     if(east[j]>=res[tek].h)
	       {
		yb++;
		if(yb==m&&check_for_collisions(tek,ii,j)==0)
		  {
		   res[tek].x=ii;
		   res[tek].y=j;
		   if(find_pos(tek+1)==1) return 1;
		   yb--;
		  }
	       }
	     else
	       yb=0;
	  xb--;
	 }
      }
     else
      xb=0;
   }
return 0;
}
////////////////////////////////////////////////////////////////////////
void swap(USINT *el1,USINT *el2)
{
USINT vrem;
/////////
vrem=*el1;
*el1=*el2;
*el2=vrem;
}
////////////////////////////////////////////////////////////////////////
void sort()
{
int	 i,j,min;
////////////////
for(i=0;i<num_blocks-1;i++)
   {
    min=num_blocks-1;
    for(j=num_blocks-2;j>=i;j--)
       if(res[min].h>res[j].h) min=j;
    swap(&(res[i].h),&(res[min].h));
    swap(&(res[i].x),&(res[min].x));
    swap(&(res[i].y),&(res[min].y));
   }
}
////////////////////////////////////////////////////////////////////////
void solve()
{
opr_blocks();
if(find_pos(0)==0) num_blocks=0;
else		   sort();
}
////////////////////////////////////////////////////////////////////////
void out()
{
FILE *fp;
int  i;
/////////
if((fp=fopen(OUT,"w"))==NULL)
   {
    clrscr();
    printf("FILE ERROR");
    getch();
    exit(0);
   }
/////////
if(num_blocks==0) fprintf(fp,"NO");
else		  fprintf(fp,"%d\n",num_blocks);
//
for(i=0;i<num_blocks;i++)
   fprintf(fp,"%d %d %d\n",res[i].x,res[i].y,res[i].h);
//
fclose(fp);
}
////////////////////////////////////////////////////////////////////////
			// Main Function //
////////////////////////////////////////////////////////////////////////
void main()
{
in();
solve();
out();
}